#include "p18F46K22.inc"
#include "config.inc"
#include "mforth.inc"
;------------------------------------------------------------------------------
;                     .
;	  	   http://tesla.zabotavdome.ru/forth.html	
;			      	 ..
;------------------------------------------------------------------------------
#define  MODEDEBUG  TRUE

;  :   80/561   PIC18(L)F2X/4XK22 
;		    http://www.mouser.com/ds/2/268/41412F-59170.pdf
	
STACK		equ	0x0BFF	;  +3840 byte.	    ;   (FSR1)

;----------------------------------------------------------------------------

SPBRG_VAL	EQU	.25	;    9600 
UA_BLEN		EQU	.80 	;    ɣ.
OUT_BufLEN	EQU	.80 	;    .		
CODE_BufLEN	EQU	.64 	;      .

;-------------------    Bit Definitions   --------------------
		
UAInitRX	EQU	0	;   ɣ.
UAInitTX	EQU	1	;   .
UAFullTX	EQU	2	;  .
UAFullRX	EQU	3	; ɣ .	
ReceivedCR	EQU	4	;  <CR> ( )

owLeft  	EQU     4	;    1
owRight 	EQU     3	;    0 
owDown  	EQU     2	;    ̣
owSecondBIT	EQU     1	;  1-wire
owFirstBIT   	EQU     0	;  1-wire

;----------------------       -----------------------

CBEGIN		EQU     0
CBREAK		EQU     1
CWHILE	    	EQU     2		
CCONTINUE	EQU     3		

;----------------------       -----------------------

ECHO		EQU	0	;   .
COMPILATOR	EQU	1	;    .
	
	CBLOCK 0x00C

	    ForthConfiguration		;   .

	    rByte			;     .
	    fwLength			;  -   

	    FWordPTRL			;    -
	    FWordPTRH			; 
	    FWordIndexL			;   (+1)  -
	    FWordIndexH			; 

	    fw_rc    			;  
	    FindWORDL			;  -  
	    FindWORDH			; 
	    FindWORDS			;  -.	    

	    BufferPTRL			;  -   
	    BufferPTRH			 
	    BufferSIZE			 

	    LastWORDL			;   - 
	    LastWORDH			;   . 
	    LastWORDU			 

	    HereCODEL			;        
	    HereCODEH			;     .
	    HereCODEU			

	    LengthWORD			;     .
	    SaveWORDL			;      
	    SaveWORDH			;    
	    SaveWORDU			

	    FlagWORD			;      
	    CodeWORDL			
	    CodeWORDH			
	    CodeWORDU			;     

	    HeapMEML			;   .
	    HeapMEMH

	    FlBufCount			;      
	    FlBufCountH			;  . 
	    FlBufCountL
	    FlCodeBEGL			;      
	    FlCodeBEGH			;   heap
	    FlBufPTRL			;    
	    FlBufPTRH			
	    FlDeepPAIRS			;  0 

	    tHex			; ޣ  (hex)
	    tLen			;   ASCII 
	    tByte			

	    tAscii
	    tAscii1		    
	    tAscii2
	    tAscii3

	    tempByteIndex 
	    tempByteOUT

	    UABufTXL			;     .  
	    UABufTXH
	    UABufFlag			;   RX/TX 
	    UABufTXCount		;    .

	    UABufRXL
	    UABufRXH			;  ,  .
	    UABufRXCount		;   

	    OUTBufL			;   .
	    OUTBufH			;   .
	    OUTBufCount			;    
	    
	    W_TEMP			;    
	    FSR0L_TEMP			;      
	    FSR0H_TEMP			; .
	    STATUS_TEMP	
	    
	    W_SHADOW			;    
	    FSR0L_SHADOW		;     
	    FSR0H_SHADOW		;   .
	    STATUS_SHADOW

            FlagTIMER0			; 1  
	    OwFlag			;  1-Wire  
	    OwCount			; ޣ 
	    OwBytes			;    c
	    
	    ;OwLast			;    . 
	    ;OwPrev			;    .
	    ;OwStart			;  ţ
	    
	    OwByte			;    .
	    OwBit			;  
	    
	    OwBitCount			;   
	    OwByteCount			;   
	    
	    ow_rcode			;      1-Wire
	    
	    OffsCOMMAND			;      FSR2
	    LoopCOMMAND			;  
	    
	    OwIndex			;   
	    OwArray:64			;   
	    
        ENDC

	CBLOCK 0x0100
	    UABuffer:UA_BLEN+1		;    
	    OUTBuffer:OUT_BufLEN+1	;  
	    FLBufferL:CODE_BufLEN	;      +00 
	    FLBufferH:CODE_BufLEN	;      +64
	    FLBufferA:CODE_BufLEN	;      +128
	    FLBufferB:CODE_BufLEN
	    FREE_DATA_MEMORY		;     
        ENDC

SDATA	equ    0x0BFF	;  +3071 byte.	    ;   (FSR1)
	CBLOCK SDATA			    ;  
	ENDC

SARGS	EQU    0x0F00	;  +3840 byte.	    ;   (FSR2)
	CBLOCK SARGS			    ;  
	ENDC

;******************************************************************************
;       ORG     0x0008      ;    .
;       ORG     0x0018      ;    
;******************************************************************************	

        ORG     0x0000
        goto    START

	ORG	0x0008
	goto    HIGH_ISR

    	ORG     0x0018		
	goto    LOW_ISR

	ORG	0x1000
;
;	       
;	  .
;	
HIGH_ISR:

	MOVWF	W_TEMP		    ;     
	SWAPF	STATUS,W	    ;    .
	MOVWF	STATUS_TEMP	    
	movff	FSR0H,FSR0H_TEMP    ;    .	
	movff	FSR0L,FSR0L_TEMP	

    	movlw   b'00000010'	    ; .  .	
        xorwf   LATE, f		    

	btfsc   INTCON,T0IF	    ;    . 
        goto    Timer0_int	    ;   .

	btfss	PIR1,RC1IF	    ;    
	goto	HIGH_ISR2	    ;  ɣ.	    

	btfsc	PIE1,RC1IE	    ;   ɣ 
	bra 	RX_BUFFER	    ;    .

HIGH_ISR2:

HIGH_END:

	movff	FSR0L_TEMP,FSR0L    ;   
	movff	FSR0H_TEMP,FSR0H    ;   
	swapf	STATUS_TEMP,W	    ;   .	
 	movwf	STATUS			
	swapf	W_TEMP,F		
	swapf	W_TEMP,W		
	RETFIE				

Timer0_int:

    	;movlw   b'00000100'		; .  
        ;xorwf   LATE, f			

        bcf     INTCON,T0IF		; C  
	bcf     T0CON, TMR0ON		;  

	;movlw   0xFE			;   
	;movwf   TMR0H
	;movwf   TMR0L			

	bra	HIGH_END		;   .

RX_BUFFER:				; ɣ   RS232

	btfsc	RCSTA,OERR		; If overrun error
	bra	ErrOERR			; Then go handle error
	btfsc	RCSTA,FERR		; If framing error
	bra	ErrFERR			; Then go handle error

RX_InitBUFFER:

	btfss	UABufFlag,UAInitRX	;    .
	bra	RX_CheckBUFFER		;   

	clrf	UABufRXCount		;    .
	bcf	UABufFlag,UAFullRX	;   .
	bcf	UABufFlag,ReceivedCR	;    .    
	
	lfsr	0,UABuffer		;    
        movff	FSR0L,UABufRXL		;  ɣ   
	movff	FSR0H,UABufRXH    
	
	bcf	UABufFlag,UAInitRX	;  .

RX_CheckBUFFER:	
    
	movf    UABufRXCount,w		;  ޣ  .
	xorlw	UA_BLEN			;     , 
	bnz	RX_SaveBYTE		;   .

	movf	RCREG,W			;   . 
	bsf	UABufFlag,UAFullRX	;   
	bsf	UABufFlag,ReceivedCR	;    

	bsf	PIE1,TX1IE		;   
	bra	HIGH_END		;   .

RX_SaveBYTE:

	bsf	PIE1,TX1IE		;    

        incf	UABufRXCount,f		;   . 
        incf	UABufTXCount,f		;    .

	movff	UABufRXH,FSR0H		;    ,
	movff	UABufRXL,FSR0L		;  .

	movf	RCREG,W			;    
	movwf	POSTINC0		;    

	movff	FSR0H,UABufRXH		;     .
	movff	FSR0L,UABufRXL		

	xorlw	0x0D			; CR ?
	bnz	HIGH_END

	bsf	UABufFlag,ReceivedCR	;    ģ 
	bra	HIGH_END		; ģ .

; an do special error handling here - this code simply clears and continues

ErrOERR:

	bcf	RCSTA,CREN		; reset the receiver logic
	bsf	RCSTA,CREN		; enable reception again
	bra	HIGH_END

;error because FERR framing error bit is set 

;can do special error handling here - this code simply clears and continues

ErrFERR:    movf    RCREG,W		;discard received data that has error
	    bra	    HIGH_END

;
;	       
;	  .
;	

LOW_ISR:    MOVWF   W_SHADOW		;     
	    SWAPF   STATUS,W		;    
	    MOVWF   STATUS_SHADOW	;   .
	    movff   FSR0H,FSR0H_SHADOW	
	    movff   FSR0L,FSR0L_SHADOW	

	    movlw   b'00000001'		; .  .
	    xorwf   LATE, f		

;   -------------------------------------------------------------------------
;	      
	    
	    btfss   PIR1,TX1IF		; test for TXIF transmit interrupt flag
	    bra	    LOW_END		; if TXIF is not set, done with test

	    btfsc   PIE1,TX1IE		;    .
	    bra	    TX_SEND		;    .
;   ------------------------------------------------------------------------- 
	    
LOW_END:	 
	    movff   FSR0L_SHADOW,FSR0L	;   
	    movff   FSR0H_SHADOW,FSR0H	
	    SWAPF   STATUS_SHADOW,W	
	    MOVWF   STATUS	
	    SWAPF   W_SHADOW,F	
	    SWAPF   W_SHADOW,W	
	    RETFIE			
	    
TX_SEND:
    
;   -------------------------------------------------------------------------
;	      . 
;   -------------------------------------------------------------------------
    
	    BRA	    TX_EXIT		
	    
	    TSTFSZ  UABufTXCount	;   , .
	    BRA	    TX_ReadySEND	 
	    
	    BTFSS   UABufFlag,UAInitTX  ;    
	    bra	    TX_EXIT
	    
	    lfsr    0,UABuffer		;    
	    movff   FSR0L,UABufTXL	;  .
	    movff   FSR0H,UABufTXH
	    bcf	    UABufFlag,UAInitTX
TX_EXIT:	    
	    bcf	    PIE1,TX1IE		;    
	    bra	    LOW_END		

TX_ReadySEND:	    

	    decf    UABufTXCount	;     
    	    movff   UABufTXL,FSR0L	;      .    
	    movff   UABufTXH,FSR0H
	    
	    movff   POSTINC0,TXREG	; TXREG -  .
	    
	    movff   FSR0L,UABufTXL
	    movff   FSR0H,UABufTXH	    
	    
	    bra	    LOW_END

InitLEDs:
	    clrf    TRISE 
	    clrf    ANSELE
	    clrf    LATE		; Turn off LEDs
    
	    return
;
;
;
START

    call    InitLEDs			;   .
    movlw   b'00000000'
    movwf   PORTE

    banksel ANSELA
    movlw   b'11011111'
    andwf   ANSELA,f

    movlw   b'00100000'
    iorwf   TRISA,f

    ;TRISA  &= 0b00100000;
    ;ANSELA &= 0b11011111;

    call    InitTimer0

    call    ow_init
    call    InitForth			
    call    InitParse
    call    InitBuffers
    rcall   InitSerial
    
loop:   

     BTFSS   UABufFlag,ReceivedCR	; ģ   0x0D,  
     bra     loop			; ( ).  .  

GET_NEXT_WORD:

    call	fwNext			;     
    tstfsz	fwLength		;     ,
    bra		FIND_FORTH_WORD		;  ,   .

    call	InitParse		;    .

    bsf		UABufFlag,UAInitRX	;  ɣ.
    bsf		UABufFlag,UAInitTX	;  .
    bcf    	UABufFlag,ReceivedCR	;    . 

    bra		loop

FIND_FORTH_WORD:

    call	ParseWord		;  ģ   .

    bra		GET_NEXT_WORD

;  .   ,  .

GetWORD:

    BTFSS	UABufFlag,ReceivedCR	; ģ   0x0D,  
    bra		GetWORD			;  .  

    call	fwNext			;     
    tstfsz	fwLength		;     , 
					;  ,   .
    return				;  .

    call	InitParse		;   .
    bsf		UABufFlag,UAInitRX	;  ɣ.
    bsf		UABufFlag,UAInitTX	;  .
    bcf    	UABufFlag,ReceivedCR	;    . 

    bra		GetWORD

;         ParseWord 
;   .    ,   wreg  
;    .    
    
ParseWord:

    ;movf	fwLength,W		;     .
    ;movff	FWordPTRL,FindWORDL		;    - 
    ;movff	FWordPTRH,FindWORDH	;   .

    ;
    ;     -.
    ;
    
    movff       fwLength,FindWORDS	;     .
    movff	FWordPTRL,FindWORDL	;    - 
    movff	FWordPTRH,FindWORDH	;   .
    
    call	FindWord		;    ?
    XORLW	.0			
    bz		CallForthWORD		;  .

    call	ASCII_BitsToBinary	;     
    XORLW	.0			; (0B11111111) ?
    bnz		Check_HexToBinary	

    btfsc	ForthConfiguration,COMPILATOR
    goto	CompileNUMBER

    return

Check_HexToBinary:			

    call	ASCII_HexToBinary	;    
    XORLW	.0			;  (0XFF)?
    bnz		Check_DecToBinary

    btfsc	ForthConfiguration,COMPILATOR
    goto	CompileNUMBER

    return

Check_DecToBinary:

    call	ASCII_DecToBinary	;      
    XORLW	.0			;  0  99 ?
    bnz		WordNotFound

    btfsc	ForthConfiguration,COMPILATOR
    goto	CompileNUMBER

    return
    
WordNotFound:				; . ģ   
					;     
    FERROR	eword			; ,  -.
    
    return

CallForthWORD:
    ;
    ;    ,    
    ;  ,      call.
    ;
    movf  FlagWORD,W

    btfsc FlagWORD,BitIMMED
    bra	  doCALL

    btfss ForthConfiguration,COMPILATOR
    bra	  doCALL

    movf  FlagWORD,W
    btfsc FlagWORD,BitCOMPILE
    bra	  doCALL

    goto  CompileCALL

doCALL:     

    ;    -   TBLPTRL
    ;        
    ;   return  .

    incf	STKPTR, F
    movf	TBLPTRL, W
    movwf	TOSL
    movf	TBLPTRH, W
    movwf	TOSH
    movf	TBLPTRU, W
    movwf	TOSU
    return

endCall:

;-------------------------------------------------------------------------
;    ASCII   WREG    
;   INDF1 -    . 
;-------------------------------------------------------------------------

ASCII_HexCheck:
    
    movwf	INDF1
    
    movlw	0x29			    
    CPFSGT	INDF1
    bra		ASCII_HexCheck_Fault    ; < 0

    movlw	0x39		
    CPFSGT	INDF1
    bra		ASCII_HexCheck_Sucsess	; < 9

    bcf		INDF1,5			; a..f -> A..F
    
    movf	INDF1,w
    movlw	0x40		
    CPFSGT	INDF1  
    bra		ASCII_HexCheck_Fault	; < A 	

    movf	INDF1,w
    movlw	0x47		
    CPFSLT	INDF1  
    bra		ASCII_HexCheck_Fault    ; > F
    
ASCII_HexCheck_Sucsess:
    
    movf	INDF1,w
    
    return 
    
ASCII_HexCheck_Fault:    

    movlw	.0
    
    return 
    
;-------------------------------------------------------------------------
;    ASCII   WREG    
;   INDF1 -    . 
;-------------------------------------------------------------------------
    
ASCII_DecCheck:
    
    movwf	INDF1
    
    movlw	0x29			    
    CPFSGT	INDF1
    bra		ASCII_DecCheck_Fault    ; < 0

    movlw	0x3A		
    CPFSLT	INDF1
    bra		ASCII_DecCheck_Fault	; < 9

    movf	INDF1,w
    
    return 
    
ASCII_DecCheck_Fault:    

    movlw	.0
    
    return 
    
; -------------------------------------------------------------------------
;         99   
;     ,    .
;   http://www.piclist.com/techref/microchip/math/radix/a2b-2d8b-sd.htm
; -------------------------------------------------------------------------
    
ASCII_DecToBinary:

    lfsr	0,tAscii1
    
    movff	FWordPTRL,FSR0L		;    - 
    movff	FWordPTRH,FSR0H		
    movff	fwLength,tLen		;     .
    
    bra		ASCII_DecToBinary_Init

ASCII_DecToBinary_Fault:
    
    movlw	.1
    
    return
    
ASCII_DecToBinary_Init:

    movf	POSTINC0,w		;  
    
    call	ASCII_DecCheck		;     0-9
    xorlw	.0				    	
    bz		ASCII_DecToBinary_Fault

    movwf	tAscii1			;  	
    movlw	0x0f			; ң ASCII 3    
    andwf	tAscii1,f		 
    
    DECFSZ	tLen			;    ģ  
    bra		ASCII_DecToBinary_Tens	; ?
		
    movff	tAscii1,POSTDEC1	;  .   . 

    movlw	.0

    return
    
ASCII_DecToBinary_Tens:			;   .
    
    movf	POSTINC0,w
    
    call	ASCII_DecCheck
    xorlw	.0
    bz		ASCII_DecToBinary_Fault

    movwf	tAscii2
    movlw	0x0f
    andwf	tAscii2,f

    DECFSZ	tLen			;    ģ  
    bra		ASCII_DecToBinary_Fault	; ?  -  .

    movf	tAscii1,w   ;      :
			    ; 2 *   + 8 *  
    rlcf	tAscii1,w   ; 2 * tens
			    ; Note that the carry is also cleared because
			    ; ascii1 is an ASCII number between 0x30-0x39
    andlw	0x1E	    ; Clear upper nibble of tens digit
			    ; In addition, we clear the shifted in carry
    movwf	tAscii1	    ; W = ascii1 = 2*original ascii1
    
    rlcf	tAscii1,f   ; ascii1 = 4*original ascii1
    rlcf	tAscii1,f   ; ascii1 = 8*original ascii1
    addwf	tAscii1,w   ; W = 2*original ascii1 + 8 *original ascii1
			    ;   = 10*original ascii1
    addwf	tAscii2,w        

    movwf	POSTDEC1
    movlw	.0

    return
    
; -------------------------------------------------------------------------
;      0xFF   
;         -  .
; -------------------------------------------------------------------------
    
ASCII_HexToBinary:

    movff	FWordPTRL,FSR0L		;    - 
    movff	FWordPTRH,FSR0H		
    movf	fwLength,W		;     .
    
    bra		ASCII_HexToBinary_Init

ASCII_HexToBinary_Fault:
    
    movlw	.1
    return
    
ASCII_HexToBinary_Init:

    movf	fwLength,w
    movff       fwLength,tLen

    movf	POSTINC0,w			;   
    xorlw	A'0'				;  0x
    bz		ASCII_HexToBinary_Attribute
    bra		ASCII_HexToBinary_Fault

ASCII_HexToBinary_Attribute:

    DCFSNZ	tLen
    bra		ASCII_HexToBinary_Convert
    
    movf	INDF0,w				
    xorlw	A'x'
    bz		ASCII_HexToBinary_Convert
	
    movf	INDF0,w
    xorlw	A'X'
    bz		ASCII_HexToBinary_Convert
    bra		ASCII_HexToBinary_Fault

ASCII_HexToBinary_Convert:

    DCFSNZ	tLen
    bra		ASCII_HexToBinary_Fault
    
    movf	PREINC0,w
    
    call	ASCII_HexCheck
    xorlw	.0
    bz		ASCII_HexToBinary_Fault
    
    addlw	0x9f		    ;   .
    bnn		AdjustHiNibble
    addlw	0x20		    ; otherwise, shift to next range of digits
    bnn		AdjustHiNibble	    ; if now positive, character was 'A' to 'F'
    addlw	0x7   
    
AdjustHiNibble:    
    
   addlw	0x0A                  
   andlw	0x0F 
   
   DCFSNZ	tLen
   bra		ASCII_HexToBinary_Sucsess
    
   movwf	tByte
   movf		PREINC0,w

   call		ASCII_HexCheck
   xorlw	.0
   bz		ASCII_HexToBinary_Fault
    
   addlw	0x9f
   bnn		AdjustLoNibble
   addlw	0x20                 ; otherwise, shift to next range of digits
   bnn		AdjustLoNibble       ; if now positive, character was 'A' to 'F'
   addlw	0x7   
   
AdjustLoNibble:
    
   addlw	0x0A                  ; shift the result to account for the alpha offset
   andlw	0x0F 

   swapf	tByte
   IORWF 	tByte,0
   
ASCII_HexToBinary_Sucsess:
    
    movwf	POSTDEC1
    
    movlw	.0
    
    return

; -------------------------------------------------------------------------
;      0b1111111   
;         -  
; -------------------------------------------------------------------------

ASCII_BitsToBinary:

    movff	FWordPTRL,FSR0L		;    - 
    movff	FWordPTRH,FSR0H		
    movf	fwLength,W		;     .
    
    bra		ASCII_BitsToBinary_Init

ASCII_BitsToBinary_Fault:
    
    movlw	.1
    return
    
ASCII_BitsToBinary_Init:
    
    movf	fwLength,w
    movff       fwLength,tLen
    
    movf	POSTINC0,w
    xorlw	A'0'
    bz		ASCII_BitsToBinary_Attribute
    bra		ASCII_BitsToBinary_Fault
    
ASCII_BitsToBinary_Attribute:
    
    movf	tLen,w
    DCFSNZ	tLen
    bra		ASCII_BitsToBinary_Convert
    
    movf	INDF0,w
    xorlw	A'b'
    bz		ASCII_BitsToBinary_Convert
	
    movf	INDF0,w
    xorlw	A'B'
    bz		ASCII_BitsToBinary_Convert
    bra		ASCII_BitsToBinary_Fault
    
ASCII_BitsToBinary_Convert:
    
    clrf	tByte	
     
    movlw	.9
    movwf       tempByteIndex 
    
ASCII_BitsToBinary_NextBit:

    movf	tLen,w			    ;      
    DCFSNZ	tLen			    ;  ,  
    bra		ASCII_BitsToBinary_Sucsess  ;   .
    
    DCFSNZ	tempByteIndex 
    bra		ASCII_BitsToBinary_NextByte
     
    rlncf	tByte,f
     
    movf	PREINC0,w
    xorlw	A'1'
    bnz		ASCII_BitsToBinary_ZeroBIT
    
    bsf		tByte,0
    bra		ASCII_BitsToBinary_NextBit

ASCII_BitsToBinary_ZeroBIT:
    
    movf	INDF0,w
    xorlw	A'0'
    bz		ASCII_BitsToBinary_NextBit
    bra		ASCII_BitsToBinary_Fault
    
ASCII_BitsToBinary_NextByte:			;  . 

ASCII_BitsToBinary_Sucsess:

    movff	tByte,POSTDEC1

    movlw	.0

    return

;    wreg ->   OUTBuffer   OUTBufL/H
    
ByteOUT:
    
	movwf   tempByteOUT
	bra	CheckFreeSpace

OutFault:

	movlw	.1
	return

CheckFreeSpace:

	movff   POSTDEC1,FSR0H
	movff   POSTDEC1,FSR0L
    
	movf	OUTBufCount,w		    ;    .
	xorlw	OUT_BufLEN		    
	bnz	BufferNotFull
	bra	OutFault		    ;   

BufferNotFull:

	incf	OUTBufCount,f	

	movff	OUTBufH,FSR0H		;    ,
	movff	OUTBufL,FSR0L		;  .

	movf	tempByteOUT,w
	movwf	POSTINC0		;    

	movff	FSR0H,OUTBufH		; Save pointer into memory
	movff	FSR0L,OUTBufL

	movlw	.0
	
	movff   PREINC1,FSR0L
	movff   PREINC1,FSR0H
	
	return

MessageERROR:

	;movlw   UPPER estack		    ; .
	;movwf   TBLPTRU
	;movlw   HIGH  estack            
	;movwf   TBLPTRH
	;movlw   LOW   estack            
	;movwf   TBLPTRL

MessageERROR_NextByte:
	
	tblrd	*+			    ;   -
	
	movlw   0
	xorwf	TABLAT,0
	bz      MessageERROR_EndOut

ML1	btfss	PIR1,TXIF		    ; ģ  
	bra	ML1
	movwf	TXREG		    
	
	bra	MessageERROR_NextByte
	
MessageERROR_EndOut:

	movlw	0x0D
ML2	btfss	PIR1,TXIF		    ; ģ  
	bra	ML2
	movwf	TXREG		    
	
	return
;
;        rs232
;
OUTrs232:

    	lfsr 	FSR0,OUTBuffer		    ;     

NextByteRS232:
    
	movf	OUTBufCount,w		    ;    ?
	xorlw	0    
	bz	SucsessOUT
	
	decf	OUTBufCount

RS1	btfss	PIR1,TXIF		    ; ģ  
	bra	RS1
	movff	POSTINC0,TXREG		    
	
	bra	NextByteRS232
	
SucsessOUT:

	OUTBufferINIT			    ; 
    
    	movlw	0x0D			    ;   *
RS2	btfss	PIR1,TXIF		    ; wait until the last bit is gone
	bra	RS2
	movwf	TXREG	

	
	return
;
;         ASCII .
;
	
BinaryToAscii:

    
    #ifdef	MODEDEBUG
    movlw	LOW STACK
    CPFSEQ	FSR1L
    bra		BinaryToAsciiInit
    movlw	HIGH STACK
    CPFSEQ	FSR1H
    bra		BinaryToAsciiInit
    
    FERROR	estack    
    return
    #endif
    
BinaryToAsciiInit:    
    
    movf	PREINC1,w
    movwf       tByte
    movlw	.9
    movwf       tempByteIndex 
    bra		NextBitToAscii
    
BinaryToAsciiFault:
    
    movlw	.1
    return

NextBitToAscii:
    
    DCFSNZ	tempByteIndex 
    bra		SucsessBinaryToAscii

    movlw	A'0'
    BTFSC	tByte,7
    movlw	A'1'
    RLNCF	tByte

    call	ByteOUT
    
    xorlw	.0
    bz  	NextBitToAscii
    bra		BinaryToAsciiFault
    
SucsessBinaryToAscii:
    
    movlw	.0
    
    return
    
;	         .    
;	
;	http://www.piclist.com/techref/microchip/math/radix/b2ah-8b2a-sd.htm

HEXtoASCII:

	    #ifdef	MODEDEBUG
	    movlw	LOW STACK
	    CPFSEQ	FSR1L
	    bra		InitHEXtoASCII
	    movlw	HIGH STACK
	    CPFSEQ	FSR1H
	    bra		InitHEXtoASCII
	    FERROR	estack    
	    return
	    #endif

InitHEXtoASCII:

    	    SWAPF    PREINC1,W	; Get upper nibble
	    
	    ANDLW   0x0F	;     .
	    ADDLW   0xF6	; add 246, to check if 0-9 or a-f, w=nibble+246
	    BTFSC   STATUS,C	; if carry set then a-f
	    ADDLW   0x07	; carry set, then add 7, w=nibble+246+7 ( note nibble known to be a-f )
	    ADDLW   0x3A	; then finally add 58 to get 'proper' ascii 
				; 1) w = low(nibble+246+58)   = 48+nibble ( if 0-9 )
				; 2) w = low(nibble+246+7+58) = 55+nibble ( if a-f )
	    call    ByteOUT	
	    xorlw   .0
	    bnz     HEXtoASCIIFault

	    movf    INDF1,W				
	    
	    ANDLW   0x0F	
	    ADDLW   0xF6	
	    BTFSC   STATUS,C	
	    ADDLW   0x07	
	    ADDLW   0x3A	

	    call    ByteOUT	; 
	    xorlw   .0
	    bnz	    HEXtoASCIIFault

	    movlw   .0
	    return

HEXtoASCIIFault:
	
	    movlw   .1
	    return
;
;      .   .
;

InitTimer0:
    
	;bsf     T0CON, TMR0ON
       
	; timer 0 config:   
	
        bsf     T0CON,TMR0ON	; enable Timer0
        bsf     T0CON,T08BIT	; 8 bits timer (0=16 bits; 1=8 bits)
        bcf     T0CON,T0CS	; timer source: internal timer of the processor
       ;bcf	T0CON,T0SE 
        bsf     T0CON,PSA	; select prescaler
        bcf     T0CON,T0PS2	; set prescaler scale to 1:128 (110)
        bcf     T0CON,T0PS1
        bcf     T0CON,T0PS0

	movlw   0x00		; load start value
	movwf   TMR0H
	movwf   TMR0L		; and write the buffer
	
	
	;bsf	INTCON,GIEL
	;bsf	INTCON,GIEH
	
        bcf     INTCON,T0IF    ; clean the overflow flag
        bsf     INTCON,TMR0IE  ; enable Timer0 interrupts
	
        return    

;
;         UART  ɣ     .
;
	
InitSerial:	

	banksel ANSELC
	bcf  	ANSELC, ANSC6	; 6 bit TX as Digital 
	bcf  	ANSELC, ANSC7	; 7 bit RX as Digital 
	
	banksel 0
	bcf  	TRISC,TX1 	; 6 bit Digital input disabled 
	bsf  	TRISC,RX1 	; 7 bit Digital input enabled  

	movlw	SPBRG_VAL	; set baud rate
	movwf	SPBRG		; SPBRG = ((int)(FOSC/(16UL * BAUD) -1));
	
	bcf	TXSTA,SYNC	; EUSART Mode 1 = Synchronous 0 = Asynchronous 
	bsf	TXSTA,TXEN	; 1 = Transmit enabled 0 = Transmit disabled 
	bcf	TXSTA,BRGH	; 1 = High speed baud rate 0 = Low speed
	bsf	TXSTA,TRMT	; Transmit Shift Register Status bit 
				; 1 = TSR empty 0 = TSR full 
	bcf	TXSTA,TX9 	; 0 - Selects 8-bit transmission

	bsf	RCSTA,SPEN	; Serial Port Enable bit
	bsf	RCSTA,SREN	; Single Receive. Asynchronous mode: Don?t care
	bsf	RCSTA,CREN	; Enable/Disable receiver 

	bcf	RCSTA,RX9D 	; 0 - Selects 8 bit of received data
	
	bsf	IPR1,RC1IP 	; Receive  Interrupt Priority bit 
	bcf	IPR1,TX1IP	; Transmit Interrupt Priority bit 
	
	bsf	PIE1,TX1IE	; Enables the transmit interrupt 
	bsf	PIE1,RC1IE 	; Receive enterrupt Enable bit

	bsf	RCON,IPEN	; Enable interrupt priorities
	bsf	INTCON,GIEL	; Enables all unmasked peripheral interrupts 
	bsf	INTCON,GIEH     ; Global Interrupt Enable bit

	MOVLW A'*'		;   *
S1	BTFSS PIR1, TXIF	; wait until the last bit is gone
	BRA S1
	MOVWF TXREG	
	return

;
;        .   .
;
	
VariablesRead:    
    
	movlw	UPPER VariablesCODE
	movwf	TBLPTRU
	movlw	HIGH  VariablesCODE
	movwf	TBLPTRH
	movlw	LOW   VariablesCODE
	movwf	TBLPTRL
	
	lfsr	FSR0,FLBufferL

	movlw	.64
	movwf	FlBufCount

VariablesNEXT:			    

	tblrd   *+
	movf	TABLAT,W
	movwf	POSTINC0
	decfsz	FlBufCount

	bra	VariablesNEXT
	
	return
;
;       .    .
;
	
VariablesModify:

	lfsr   FSR0,FLBufferL
	
	movff  HeapMEML, POSTINC0
	movff  HeapMEMH, POSTINC0

	movff  LastWORDL, POSTINC0
	movff  LastWORDH, POSTINC0
	movff  LastWORDU, POSTINC0

	movff  HereCODEL, POSTINC0
	movff  HereCODEH, POSTINC0
	movff  HereCODEU, POSTINC0
	
	return
	
;
;    64    .    .
;
	
VariablesErase:
    
    movlw   UPPER VariablesCODE
    movwf   TBLPTRU
    movlw   HIGH  VariablesCODE
    movwf   TBLPTRH
    movlw   LOW   VariablesCODE
    movwf   TBLPTRL
	
    bsf	    EECON1,EEPGD
    bcf	    EECON1,CFGS
    bsf	    EECON1,WREN
    bsf	    EECON1,FREE
    bcf	    INTCON,GIE

    movlw   0x55
    movwf   EECON2
    movlw   0xAA
    movwf   EECON2

    bsf	    EECON1,WR
    bsf	    INTCON,GIE
    btfsc   EECON1,WR
    bra	$-2
	
    return

;
;    64    .    .
;
	
VariablesWrite:
    
	movlw	UPPER VariablesCODE
	movwf	TBLPTRU
	movlw	HIGH  VariablesCODE
	movwf	TBLPTRH
	movlw	LOW   VariablesCODE
	movwf	TBLPTRL

	lfsr	FSR0,FLBufferL
	
	movlw   .8
	movwf   FlBufCountH
	
	
WRITE_VARIABLE_BACK:

	movlw   .8		    ; number of bytes in holding register
	movwf   FlBufCountL

WRITE_VARIABLE_BYTE_TO_HREGS:

	movf	POSTINC0,W
	movwf   TABLAT		    ; present data to table latch
	TBLWT*+			    ; write data, perform a short write
        decfsz  FlBufCountL	    ; loop until buffers are full
	
	BRA	WRITE_VARIABLE_BYTE_TO_HREGS

PROGRAM_VARIABLE_MEMORY

	BSF	EECON1,EEPGD	    ; point to Flash program memory
	BCF	EECON1,CFGS	    ; access Flash program memory
	BSF	EECON1,WREN	    ; enable write to memory
	BCF	INTCON,GIE	    ; disable interrupts
	MOVLW	55h
	MOVWF	EECON2		    ; write 55h
	MOVLW	0AAh
	MOVWF	EECON2		    ; write 0AAh
	BSF	EECON1,WR 
	
	DECFSZ  FlBufCountH
	BRA	WRITE_VARIABLE_BACK
    
	BSF	INTCON,GIE	    ; re-enable interrupts
	BCF	EECON1,WREN	    ; disable write to memory
    
	return
	
;	 .   -.   
;	      ,  .
;	  FreeMEMORY	   , -.	
	
InitForth:
    
	lfsr	FSR1,SDATA			;      
	lfsr	FSR2,SARGS			;   
	
	bsf	ForthConfiguration,ECHO		;   .
	bcf	ForthConfiguration,COMPILATOR	;  
	
	movlw	HIGH FREE_DATA_MEMORY	    ;     
	movwf	HeapMEMH		    ; 
	
	movlw	LOW FREE_DATA_MEMORY	    
	movwf	HeapMEML

	movlw	UPPER WGCHAR		    ;     
	movwf	LastWORDU		    ;  		    
	
	movlw	HIGH  WGCHAR
	movwf	LastWORDH
	
	movlw	LOW   WGCHAR
	movwf	LastWORDL

	movlw	UPPER HereCODE		    ;     
	movwf	HereCODEU		    ;  .
	
	movlw	HIGH  HereCODE
	movwf	HereCODEH
	
	movlw	LOW   HereCODE
	movwf	HereCODEL
	
	movlw	UPPER VariablesCODE	    ;   
	movwf	TBLPTRU			    ;    .
	movlw	HIGH  VariablesCODE	
	movwf	TBLPTRH
	movlw	LOW   VariablesCODE
	movwf	TBLPTRL
	
	return				    ; .    
;	
;	      .
; 
	TBLRD*+			    
	movf	TABLAT,W
	bnz	SkipInitialization
	TBLRD*
	movf	TABLAT,W
	bnz	SkipInitialization
    
	movlw   b'00000111'
	movwf   PORTE
	
	call	 VariablesRead	    ;  64      	
	call	 VariablesModify    ;       
	call	 VariablesErase	    ;   
	call	 VariablesWrite	    ;    .

	call	 VariablesRead	    ;  64      	
	
SkipInitialization:

	movlw	UPPER VariablesCODE
	movwf	TBLPTRU
	movlw	HIGH  VariablesCODE
	movwf	TBLPTRH
	movlw	LOW   VariablesCODE
	movwf	TBLPTRL

	TBLRD*+			    
	movf	TABLAT,W
	movwf   HeapMEML  
	TBLRD*+			    
	movf	TABLAT,W
	movwf   HeapMEMH  

	TBLRD*+			    
	movf	TABLAT,W
	movwf   LastWORDL
	TBLRD*+			    
	movf	TABLAT,W
	movwf   LastWORDH
	TBLRD*+			    
	movf	TABLAT,W
	movwf   LastWORDU
	
	lfsr    0,LastWORDL 

	TBLRD*+			    
	movf	TABLAT,W
	movwf   HereCODEL
	TBLRD*+			    
	movf	TABLAT,W
	movwf   HereCODEH
	TBLRD*+			    
	movf	TABLAT,W
	movwf   HereCODEU
	
	lfsr    0,HereCODEL 

	return

InitBuffers:
;1   
	lfsr	0,UABuffer
	
	clrf	UABufFlag		;  
	clrf    UABufRXCount		;    .
	clrf    UABufTXCount		;     .
	
	movff   FSR0L,UABufTXL		;    
	movff   FSR0H,UABufTXH
	
	movff   FSR0L,UABufRXL		;     
	movff   FSR0H,UABufRXH

	movlw	0x0D			;    (+1)   
	movwf   tByte			;   .
	movlw	UA_BLEN
    	movff	tByte,PLUSW0
;
;	Init output buffer
;
	clrf    OUTBufCount		;     
	lfsr	FSR0,OUTBuffer
	movff   FSR0L,OUTBufL		;    
	movff   FSR0H,OUTBufH		

	return

InitParse:				;   
					;    .
    	clrf 	 fwLength		
	lfsr	 FSR0, UABuffer
	
	movff    FSR0L,FWordPTRL
	movff    FSR0H,FWordPTRH
	
	movff    FSR0L,FWordIndexL
	movff    FSR0H,FWordIndexH
	
	return

	
echo:	    BTFSS	ForthConfiguration, ECHO	;   ?
	    bra		SkipEcho
gwait:	    BTFSS	PIR1, TXIF			;  
	    BRA		gwait
	    MOVWF	TXREG	
SkipEcho:   
	    return
	
fwNext:	
;2    
    	clrf 	 fwLength		;   -
	movff    FWordIndexL,FSR0L	;    
	movff    FWordIndexH,FSR0H
	
	movf	 INDF0,W
	movff	 INDF0,rByte
	
SkipNotCHAR:
    
	movf	rByte,W
	movlw	0x0D			; CR -   .
	xorwf   rByte,0		 
	bnz	CheckBackSlash
	
	movff   FSR0L, FWordIndexL
	movff   FSR0H, FWordIndexH	

	return
	
CheckBackSlash:				;    
    
	movf	rByte,W
	movlw	0x5C			; Back Slash 
	xorwf   rByte,W		 
	bnz	CheckDelete

	movf	rByte,w
	call	echo
	
FindEndSTRING:

	movf	PREINC0,W
	movwf	rByte
	
	call	echo

	movlw	0x0D			; CR -   .
	xorwf   rByte,W
	bnz	FindEndSTRING

	movff   FSR0L, FWordIndexL
	movff   FSR0H, FWordIndexH	
	
	return
	
CheckDelete:
    
	movlw	0x07F			; DELETE CHAR
	xorwf   rByte,0		
	bz	FWSkipSPACE

	movlw	0x21			; SPACE and NOT ASCII
	CPFSLT	rByte 
	bra	FWBeginWORD
	
    
FWSkipSPACE:

	movf	rByte,w
	call	echo

	movf	PREINC0,W
	movwf	rByte
	
	bra	SkipNotCHAR

FWBeginWORD:

	movff	FSR0L,FWordPTRL		; Save address of the first char
	movff	FSR0H,FWordPTRH

FWordCHAR:

    	movf	rByte,w
	call	echo

	movlw	0x07F			; DELETE CHAR
	xorwf   rByte,0		
	bz	FWEndWORD

	movlw	0x20			; SPACE and NOT ASCII
	CPFSGT	rByte 
	bra	FWEndWORD

	incf	fwLength
	movff	PREINC0,rByte
	bra	FWordCHAR

FWEndWORD:	

	movff   FSR0L, FWordIndexL	;  
	movff   FSR0H, FWordIndexH
	return

;-----------------------------------------------------------------------------
;          
;-----------------------------------------------------------------------------

FindWord:

	movff	LastWORDU,TBLPTRU       ;    -.    
	movff	LastWORDH,TBLPTRH	
	movff	LastWORDL,TBLPTRL

FindPrevious:

	movf    FindWORDS,W		;     .
	movff	FindWORDL,FSR0L		;    - 
	movff	FindWORDH,FSR0H		;   .

	tstfsz	TBLPTRL			;     .
	bra     FindLengthEQ		;  ,  ,
	tstfsz	TBLPTRH			;    . 
	bra     FindLengthEQ
	
	movlw	.1			
	movwf	fw_rc			;    . 
;
;	    .        WREG, fw_rc.
;	
	return
	
FindLengthEQ:
    
	tblrd	*+			;   -
	xorwf	TABLAT,1		;   TABLAT
	BZ	LengthEQ		;  ͣ 
	tblrd	+*			;   -
	movf	TABLAT,W		;    .
	tblrd	+*			;    
	movff	TABLAT,TBLPTRH		;      
	movwf	TBLPTRL
	
	bra	FindPrevious
	
LengthEQ:				;  ͣ  

	movwf   LengthWORD		;  .   .
	tblrd	*
    	movff	TABLAT,FlagWORD		;   
	tblrd	+*			  
	movff	TABLAT,SaveWORDL	;    .
	tblrd	+*			    
	movff	TABLAT,SaveWORDH

FindCompareBYTES:
	
	movf	POSTINC0,W		;     .
    	tblrd	+*			;     .
	xorwf	TABLAT,0		;   W .
	bz      FindBytesEQ		;   
	
	movff	SaveWORDH,TBLPTRH	;   
	movff	SaveWORDL,TBLPTRL	;  .

	bra	FindPrevious		;   ,  
    
FindBytesEQ:

	DECFSZ  LengthWORD		;    .
	BRA	FindCompareBYTES	;  ,   . 
;
;	   .	      .
	
	BTFSC	TBLPTRL,0		;   -.
	tblrd	+*			;    ޣ 

	movlw	.0			; WREG = 0 -  .
					; TBLPTRL  -   .
	movwf	fw_rc			;    . 
					
;
;	   .	     .
	
	return

;----------------------------------------------------------------------------
;	 64    . 
;	TBLPTRU:TBLPTRH:TBLPTRL -     
;----------------------------------------------------------------------------
	
EraseCodeHERE:

	bsf	EECON1,EEPGD
	bcf	EECON1,CFGS
	bsf	EECON1,WREN
	bsf	EECON1,FREE
	bcf	INTCON,GIE
	
	movlw	0x55
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	
	bsf	EECON1,WR
	bsf	INTCON,GIE
	
	;btfsc	EECON1,WR
	;bra	$-2
	
	return
	
;----------------------------------------------------------------------------
;	FSR0 -     . 
;	TBLPTRU:TBLPTRH:TBLPTRL -     
;----------------------------------------------------------------------------
WriteCodeHERE:
;
        banksel FlBufCountH
	
	movlw	.64		    ;     
	movwf	FlBufCount
	movlw   .8
	movwf   FlBufCountH
	
WRITE_HERE_BLOCK:

	movf    FlBufCountH,W
	nop
	movlw   .8		    ; number of bytes in holding register
	movwf   FlBufCountL

WRITE_HERE_BYTES:

        decfsz  FlBufCount	   ; TBLWT *+     
	BRA	WRITE_HERE_NEXT    ;   TABLAT .

	movf	POSTINC0,W	   
	movwf   TABLAT		    
	TBLWT   *		    
	
	bra 	PROGRAM_CODE_HERE
	
WRITE_HERE_NEXT:

	movf    FlBufCountL,w
	
	movf	POSTINC0,W
	movwf   TABLAT		    ; present data to table latch
	TBLWT   *+		    ; write data, perform a short write
	
        decfsz  FlBufCountL	    ; loop until buffers are full
	BRA	WRITE_HERE_BYTES

PROGRAM_CODE_HERE
	
	BSF	EECON1,EEPGD        ; point to Flash program memory
	BCF	EECON1,CFGS         ; access Flash program memory
	BSF	EECON1,WREN         ; enable write to memory
	BCF	INTCON,GIE	    ; disable interrupts

	MOVLW   55h
	MOVWF   EECON2		    ; write 55h
	MOVLW   0AAh
	MOVWF   EECON2		    ; write 0AAh
	BSF	EECON1,WR	    ; start program (CPU stall)
	
	btfsc	EECON1,WR	    ; pause nop or btfsc (!)
	bra	$-2
	
	DECFSZ  FlBufCountH
	BRA	WRITE_HERE_BLOCK
	
	BSF	INTCON,GIE	    ; re-enable interrupts
	BCF	EECON1,WREN	    ; disable write to memory
    
	return
	
ReadCodeHERE:   
    
	movff	HereCODEU,TBLPTRU   ;  HereCODE    			    
	movff	HereCODEH,TBLPTRH   ;    	    
	movff	HereCODEL,TBLPTRL
	
	lfsr	FSR0,FLBufferL	    ;    
	movlw	B'00111111'	    ;      ,  
	andwf	TBLPTRL,w	    ;    
	addwf	FSR0L,f		    ; flash      
	movlw	.0		    ; HereCODE
	addwfc	FSR0H,f
	
	movff	FSR0H,FlCodeBEGH    ;      
	movff	FSR0L,FlCodeBEGL    ;     .

	movff	FSR0H,FlBufPTRH	    ;    .
	movff	FSR0L,FlBufPTRL	    ;    .
	
	movlw	B'11000000'	    ;  ,  0:5 . 
	andwf	TBLPTRL,f	    ;      
				    ;   HereCODEU

	lfsr	FSR0,FLBufferL	    ;     .
	
	movlw	.128		    ;    HereCODE   
	movwf	FlBufCount	    ;        
				    ; 64-    . 

ReadCodeNEXT:		

	tblrd   *+
	movff	TABLAT,POSTINC0
	decfsz	FlBufCount
	bra	ReadCodeNEXT
	return
	
MakeVariable:

	call	MakeNameFields		; FSR0    
					;    
;
;	  ?       call
;
	movlw	UPPER VCLEN		;   
	movwf	TBLPTRU			; . 
	movlw	HIGH  VCLEN		;    : 
	movwf	TBLPTRH			; call doVariable
	movlw	LOW   VCLEN		; ң ,  
	movwf	TBLPTRL			; , .

    	tblrd	*+			;     ,
	movff   TABLAT,tLen		;  .

CopyCommandCALL:			
    
    	tblrd	+*			;    
	movff	TABLAT,POSTINC0		;   .
	DECFSZ  tLen			;    ?
	BRA	CopyCommandCALL	

	movff	HeapMEMH,POSTINC0	;    .
 	movff	HeapMEML,POSTINC0	

	movff	FSR0H,FlBufPTRH		;   .
	movff	FSR0L,FlBufPTRL		;     .

	movlw	.2			;    . 
	addwf	HeapMEML,f		;   . 
	movlw	.0			;   .
	addwfc	HeapMEMH,f
;
;	       FLBufferL
;	
	movff	HereCODEU,TBLPTRU	;   
	movff	HereCODEH,TBLPTRH	;    , 64-  
	movff	HereCODEL,TBLPTRL	;  flash . 
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	Call	EraseCodeHERE		;  .
	
	movff	HereCODEU,TBLPTRU	 
	movff	HereCODEH,TBLPTRH
	movff	HereCODEL,TBLPTRL
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	lfsr	FSR0,FLBufferL		;   .
	Call	WriteCodeHERE		;   	
;
;	       FLBufferH
;	
	movff	HereCODEU,TBLPTRU	;   
	movff	HereCODEH,TBLPTRH	;    , 64-  
	movff	HereCODEL,TBLPTRL	;   .
	movlw	B'11000000'		;  0:5 .
	andwf	TBLPTRL,f		;    64-  
	movlw	.64			;    
	addwf	TBLPTRL,f
	movlw	.0
	addwfc	TBLPTRH,f
	addwfc	TBLPTRU,f
	Call	EraseCodeHERE		; 
	
	movff	HereCODEU,TBLPTRU
	movff	HereCODEH,TBLPTRH
	movff	HereCODEL,TBLPTRL
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	movlw	.64
	addwf	TBLPTRL,f
	movlw	.0
	addwfc	TBLPTRH,f
	addwfc	TBLPTRU,f
	lfsr	FSR0,FLBufferH		  ;    .  
	Call	WriteCodeHERE

	movff	HereCODEL,LastWORDL	  ;     
	movff	HereCODEH,LastWORDH	  ;     
	movff	HereCODEU,LastWORDU	

	movf	FlCodeBEGL,w		  ;   FlBufPTRL/
	subwf	FlBufPTRL,w		  ;      255 .  

;	lfsr	FSR0,FLBufferL		  ;   FlBufPTRL/
;	movf	FSR0L,w
;	subwf	FlBufPTRL,w		    

	addwf	HereCODEL,f		
	movlw	.0
	addwfc	HereCODEH,f
	addwfc	HereCODEU,f

	return
;	
;	  .      .
;	
	movf	LastWORDU,w		;   .
	movwf	TBLPTRU
	movf	LastWORDH,w
	movwf	TBLPTRH
	movf	LastWORDL,w
	movwf	TBLPTRL

    	tblrd	*+			;   
	movf 	TABLAT,W
	movwf	tLen

    	tblrd	*+			;  
	movf	TABLAT,W

    	tblrd	*+			;   
	movf	TABLAT,W
    	tblrd	*+			;  
	movf	TABLAT,W

SkipNCF
	tblrd	*+			;   
	movf	TABLAT,W
	decfsz  tLen 
	BRA	SkipNCF

	BTFSC	TBLPTRL,0		;      
	tblrd	*+			;    ޣ.
	
	incf	STKPTR, F		;    doVariable
	movf	TBLPTRL, W
	movwf	TOSL
	
	movf	TBLPTRH, W
	movwf	TOSH

	movf	TBLPTRU, W
	movwf	TOSU

    	;tblrd	*+			;  
	;movf	TABLAT,W
    	;tblrd	*+			; 
	;movf	TABLAT,W
    	;tblrd	*+			; 
	;movf	TABLAT,W
    	;tblrd	*+			; 
	;movf	TABLAT,W

	return 

VCLEN	dw	VWPTR - VCALL		;   call ( )
VCALL	call	doVariable		
VWPTR	dw      0x1000			;    
	    
doVariable:
	
	movf	TOSL,w			;     
	movwf	TBLPTRL			;      .
	movf	TOSH,w			;     
	movwf	TBLPTRH			;     VWPTR
	movf	TOSU,w			;     
	movwf	TBLPTRU			;  .    
	decf	STKPTR, F		;     .
	
	tblrd	*+			;     
	movf	TABLAT,w		; 
	movwf   POSTDEC1		;     .

	tblrd	*			;     
	movf	TABLAT,w		;     .
	movwf   POSTDEC1		

	return

PairsPUSH: 
    
	movlw	.0			  ;     	 		
	movwf	POSTDEC1		  ;  0x0000	
	movwf	POSTDEC1		
	return
	
PairsPOP: 
    
	movlw	.0			  ;     
	xorwf	PREINC1,w		  ;  0x0000.    
	bnz	CompleBracketsERROR	  ;  if/end .   
	movlw	.0			  ;     
	xorwf	PREINC1,w		  ;     0x0000 
	bnz	CompleBracketsERROR
	
	return

CompleBracketsERROR:
	
        FERROR	epairs
	
	return

CompileLEAVE:

    movff	FlBufPTRL,FSR0L		;     
    movff	FlBufPTRH,FSR0H		;   .

    movff	FSR0H,POSTDEC2		;      
    movff	FSR0L,POSTDEC2		;  goto (break)
    movlw	CBREAK			;     
    movwf	POSTDEC2		;  (break)

    movlw	0xFF			;     goto
    movwf	POSTINC0		; (else)   end (if).
    movwf	POSTINC0		
    movwf	POSTINC0		
    movwf	POSTINC0		

    movff	FSR0L,FlBufPTRL		;     
    movff	FSR0H,FlBufPTRH		;  (goto) else.

    return
;
;     BEGIN/UNTIL      
;      IF/ELSE/THEN.  -   
;           if/else/then
	
CompileBEGIN:

	call BackMARK

	;movff   FlBufPTRH,POSTDEC2	;       
	;movff   FlBufPTRL,POSTDEC2	; .	 
	
	return

CompileUNTIL:

	movff	FlBufPTRH,FSR0H    	;      
	movff	FlBufPTRL,FSR0L		; .

	movlw	UPPER UNCLEN		;   .  
	movwf	TBLPTRU			;     wreg  
	movlw	HIGH  UNCLEN		;  ̣.   ,   
	movwf	TBLPTRH			;  begin
	movlw	LOW   UNCLEN		
	movwf	TBLPTRL			

    	tblrd	*+			;    
	movff   TABLAT,tLen		;  . 

CopyUNTIL:

    	tblrd	+*			
	movff	TABLAT,POSTINC0		
	
	DECFSZ  tLen			;    ?
	BRA	CopyUNTIL
	
    	movff	FSR0L,FlBufPTRL		;    .
	movff	FSR0H,FlBufPTRH	

	call	BackRESOLVE		;  goto  

    	movff	FlBufPTRL, FSR0L	;    .
	movff	FlBufPTRH, FSR0H
	
	call	LeaveRESOLVE		;  goto    
	
	call	ClearLOOP
	
	return

UNCLEN	dw	UNGOTO - UNCODE		;  until
UNCODE	movlw   .0			;     
	xorwf   PREINC1,w		;   ̣.
	bnz     UNBNZ			 
UNGOTO	goto    0x0000			;     .
UNBNZ	nop
	return


CompileAGAIN:

	call	BackRESOLVE		;  goto  
	call	LeaveRESOLVE		;  goto    
	call	ClearLOOP
	
	return
	
;
CompileIF:
;
	movff	FlBufPTRH,FSR0H    	;      
	movff	FlBufPTRL,FSR0L		; .

	movlw	UPPER IFCLEN		;   .  
	movwf	TBLPTRU			;     wreg  
	movlw	HIGH  IFCLEN		;  ̣.     
	movwf	TBLPTRH			
	movlw	LOW   IFCLEN		
	movwf	TBLPTRL			

    	tblrd	*+			;    
	movff   TABLAT,tLen		;  . 

CopyIF:	tblrd	+*			
	movff	TABLAT,POSTINC0		
	DECFSZ  tLen			;    ?
	BRA	CopyIF

    	movff	FSR0L, FlBufPTRL	;    .
	movff	FSR0H, FlBufPTRH	

	call	ForwardMARK
    
	return

IFCLEN	dw	IFGOTO - IFCODE		;  if
IFCODE	movlw   .0			;     
	xorwf   PREINC1,w		;   ̣.
	bnz     IFBNZ			 
IFGOTO	goto    0x0000			;     .
IFBNZ:	nop

CompileELSE:

;	   else   goto   
;	    if     
;	    .

    	movff	FlBufPTRL,FSR0L		;     
	movff	FlBufPTRH,FSR0H		;   .

	movff	PREINC1,FlBufPTRL	;     goto (if)
	movff	PREINC1,FlBufPTRH	;     .

	movff   FSR0H,POSTDEC1		;      
	movff   FSR0L,POSTDEC1		;  goto (else)
	
	movlw	0xFF			;     goto
	movwf   POSTINC0		; (else)   end (if).
	movwf   POSTINC0		
	movwf   POSTINC0		
	movwf   POSTINC0		

	movff   FlBufPTRH,POSTDEC1	;      
	movff   FlBufPTRL,POSTDEC1	; goto (if)

	movff	FSR0L,FlBufPTRL		;     
	movff	FSR0H,FlBufPTRH		;  (goto) else.

	call    ForwardRESOLVE		;      goto (if)
	return

BackMARK:

	movff   FlBufPTRH,POSTDEC2	;       
	movff   FlBufPTRL,POSTDEC2	;   GOTO -  .

	movlw   CBEGIN			;    00 - BEGIN
        movwf   POSTDEC2		; 

	return

;=============================================================================	
;     break - 
;=============================================================================	
LeaveRESOLVE:

	movlw	CBREAK			; ,    break
	call	FindCOMMAND
	xorlw   CBREAK
	bz	LeaveRESOLVE1
	return

LeaveRESOLVE1:
	
       	movff	FlBufPTRL,FSR0L
	movff	FlBufPTRH,FSR0H

;	   goto      break

	movf	 FlCodeBEGH,W	    ;  FSR0 . 
        subwf    FSR0H,F	    ;  -  .
	movf     FlCodeBEGL,W
	subwf    FSR0L,F			
	btfss    STATUS,C	    ;  
	decf	 FSR0H,F	    ;  ,     1

;	  FSR0H/FSR0L -  .  

	movff	HereCODEL,TBLPTRL	;   
	movff	HereCODEH,TBLPTRH	;    goto. 
	movff	HereCODEU,TBLPTRU	;     HereCODE

	movf	FSR0L,W			;     
	addwf	TBLPTRL,F		; .  .
	btfsc   STATUS,C
	incf    TBLPTRH,F    
	btfsc   STATUS,C
	incf    TBLPTRU,F    

	movf	FSR0H,W
	addwf	TBLPTRH,F
	btfsc   STATUS,C
	incf    TBLPTRU,F    

;	  goto:  EF kkkk kkkk  F kkkk kkkk kkkk 

	RRNCF	TBLPTRU, F	    ;    , 
	RRCF	TBLPTRH, F	    ;     
	RRCF	TBLPTRL, F

;
;	       .
;	

LeaveRESOLVE2:
	movf 	OffsCOMMAND,W	    ;   
	addlw	.1
	movff	PLUSW2,FSR0L	    ;    
	addlw	.1
	movff	PLUSW2,FSR0H	    ; while/goto   

	movff   TBLPTRL,POSTINC0    ; 0:7  	
	movlw	0xEF		    ;  
	movwf   POSTINC0    
	
	movff   TBLPTRH,POSTINC0    ; 8:15  
    
	movlw	0xF0		    ; 16:20 -  
	iorwf	TBLPTRU,W
	movwf   POSTINC0		

	movlw	CBREAK			; ,    break
	call	FindCOMMNAD_NEXT
	movf	PLUSW2,W
	xorlw   CBREAK
	bz	LeaveRESOLVE2
	return

BackRESOLVE:
   
	movlw	CBEGIN
	call	FindCOMMAND
	
	addlw	.1			;   . 
	movff	PLUSW2,FSR0L    	;      
	addlw	.1
	movff	PLUSW2,FSR0H		; .

	;  BEGIN   FSR2     
	;     

	;     .   
	;    .  -  .

	movf    FlCodeBEGH,W		; FSR0 .    
        subwf   FSR0H,F			;    255 .

	movf    FlCodeBEGL,W
	subwf   FSR0L,F			;    255 .
	btfss   STATUS,C		;   ,   2-3 
	decf	FSR0H,F			; ,     1

	;   FSR0H/FSR0L -  .  

	movff	HereCODEL,TBLPTRL	;   
	movff	HereCODEH,TBLPTRH	;    goto. 
	movff	HereCODEU,TBLPTRU	;     HereCODE

	movf	FSR0L,W			;     
	addwf	TBLPTRL,F		; .  .
	btfsc   STATUS,C
	incf    TBLPTRH,F    
	btfsc   STATUS,C
	incf    TBLPTRU,F    

	movf	FSR0H,W
	addwf	TBLPTRH,F
	btfsc   STATUS,C
	incf    TBLPTRU,F    

;	  goto:  EF kkkk kkkk  F kkkk kkkk kkkk 

    	movff	FlBufPTRL,FSR0L	    ;    
	movff	FlBufPTRH,FSR0H	    ; goto   

	RRNCF	TBLPTRU, F	    ;    , 
	RRCF	TBLPTRH, F	    ;     
	RRCF	TBLPTRL, F

	movff   TBLPTRL,POSTINC0    ; 0:7  	
	movlw	0xEF		    ;  
	movwf   POSTINC0    

	movff   TBLPTRH,POSTINC0    ; 8:15  

	movlw	0xF0		    ; 16:20 -  
	iorwf	TBLPTRU,W
	movwf   POSTINC0		
	
    	movff	FSR0L, FlBufPTRL	
	movff	FSR0H, FlBufPTRH	
	
	return

CompileWHILE:

;	  while   goto   
;	        .  
;	     whil  .

	movff	FlBufPTRH,FSR0H    	;      
	movff	FlBufPTRL,FSR0L		; .

	movlw	UPPER WHCLEN		;   .  
	movwf	TBLPTRU			;     wreg  
	movlw	HIGH  WHCLEN		;  ̣.     
	movwf	TBLPTRH			
	movlw	LOW   WHCLEN		
	movwf	TBLPTRL			

    	tblrd	*+			;    
	movff   TABLAT,tLen		;  . 

CopyWHILE:			

    	tblrd	+*			
	movff	TABLAT,POSTINC0		
	DECFSZ  tLen			;    ?
	BRA	CopyWHILE

	movff   FSR0H,POSTDEC2		;     
	movff   FSR0L,POSTDEC2		;    GOTO -   FSR2
	movlw   CWHILE			;   WHILE
	movwf   POSTDEC2		;  

	movlw	0xFF			;     goto,
	movwf   POSTINC0		;   repeat
	movwf   POSTINC0		
	movwf   POSTINC0
	movwf   POSTINC0	

    	movff	FSR0L, FlBufPTRL	;     
	movff	FSR0H, FlBufPTRH	; .

	return

WHCLEN	dw	WHGOTO - WHCODE		;  while 
WHCODE	movlw   .0			;     
	xorwf   PREINC1,w		;   ̣.
	bnz     WHBNZ			 
WHGOTO	goto    0x0000			;     .
WHBNZ	nop


Stack2SWAP:	
    
	movlw    .1		    ;      
	movff    PLUSW2,INDF1
	movlw    .3		    
	movff    PLUSW2,INDF2
	movff    INDF1,PLUSW2
	movlw    .1		    
	movff    INDF2,PLUSW2

	movlw    .2		    ;    INDF1
	movff    PLUSW2,INDF1
	movlw    .4		    
	movff    PLUSW2,INDF2	    ; ף    INDF2
	movff    INDF1,PLUSW2       ;       
	movlw    .2		    
	movff    INDF2,PLUSW2	    ; ף    

	return;

Stack3SWAP:	
    
	movlw    .1		    ;      
	movff    PLUSW2,INDF1
	movlw    .4		    
	movff    PLUSW2,INDF2
	movff    INDF1,PLUSW2
	movlw    .1		    
	movff    INDF2,PLUSW2

	movlw    .2		    ;    INDF1
	movff    PLUSW2,INDF1
	movlw    .5		    
	movff    PLUSW2,INDF2	    ; ף    INDF2
	movff    INDF1,PLUSW2       ;       
	movlw    .2		    
	movff    INDF2,PLUSW2	    ; ף    

	movlw    .3		    ;    INDF1
	movff    PLUSW2,INDF1
	movlw    .6		    
	movff    PLUSW2,INDF2	    ; ף    INDF2
	movff    INDF1,PLUSW2       ;       
	movlw    .3		    
	movff    INDF2,PLUSW2	    ; ף    
	
	return
	
	;movlw    .1
	;movff    PLUSW2,FSR0L
	;movlw    .2
	;movff    PLUSW2,FSR0H
	;movlw    .3
	;movff    PLUSW2,FSR0L
	;movlw    .4
	;movff    PLUSW2,FSR0H
	
;    
; =========================================================================	
;	
FindCOMMNAD_NEXT:

	movwf	LoopCOMMAND
	
	movlw	.3
	ADDWF	OffsCOMMAND,W
	movwf	OffsCOMMAND

FindCOMMNAD_NEXT1:

        movf    PLUSW2,W
	xorwf   LoopCOMMAND,W
	bz	FindCOMMNAD_NEXT3

	movf	OffsCOMMAND,W
	movf    PLUSW2,W
	xorlw   CBEGIN 
	bnz	FindCOMMNAD_NEXT2
	movf	OffsCOMMAND,W
	return
	
FindCOMMNAD_NEXT2:

	movlw	.3
	ADDWF	OffsCOMMAND,W
	movwf	OffsCOMMAND

	bra	FindCOMMNAD_NEXT1

FindCOMMNAD_NEXT3:

	;incf 	OffsetBEGIN
	movf	OffsCOMMAND,W

	return
;    
; =========================================================================	
;	
FindCOMMAND:

	movwf	LoopCOMMAND
	movlw	.1
	movwf	OffsCOMMAND

FindCOMMAND1:

        movf    PLUSW2,W
	xorwf   LoopCOMMAND,W
	bz	FindCOMMAND2
	
	movf	OffsCOMMAND,W
	movf    PLUSW2,W
	xorlw   CBEGIN 
	bnz	FindCOMMAND3
	return

FindCOMMAND3:
	
	movlw	.3
	ADDWF	OffsCOMMAND,W
	movwf	OffsCOMMAND
	bra	FindCOMMAND1

FindCOMMAND2:

	;incf 	OffsetBEGIN
	movf	OffsCOMMAND,W

	return
;    
; =========================================================================	
;	
ClearLOOP:
    
        movf    PREINC2,W
	xorwf   CBEGIN,W
	bz	ClearLOOP1

	movf    PREINC2,W
	movf    PREINC2,W
	bra	ClearLOOP

ClearLOOP1:

	movf    PREINC2,W
	movf    PREINC2,W

	return
;    
; =========================================================================	
;	
CompileREPEAT:
    
	;     goto  while.   begin
	;      .  
        ;    FSR2  .
	
	movlw	CBEGIN
	call	FindCOMMAND

	addlw	.1			;   . 
	movff	PLUSW2,FSR0L		;    
	addlw	.1
	movff	PLUSW2,FSR0H		; begin/goto   

	movf	FlCodeBEGH,W		;  FSR0 . 
        subwf   FSR0H,F			;  -  .
	movf    FlCodeBEGL,W
	subwf   FSR0L,F

	btfss   STATUS,C		;  
	decf	FSR0H,F			;  ,     1

;	  FSR0H/FSR0L -  .  

	movff	HereCODEL,TBLPTRL	;   
	movff	HereCODEH,TBLPTRH	;    goto. 
	movff	HereCODEU,TBLPTRU	;     HereCODE

	movf	FSR0L,W			;     
	addwf	TBLPTRL,F		; .  .
	btfsc   STATUS,C
	incf    TBLPTRH,F    
	btfsc   STATUS,C
	incf    TBLPTRU,F    

	movf	FSR0H,W
	addwf	TBLPTRH,F
	btfsc   STATUS,C
	incf    TBLPTRU,F
;
;	  goto:  EF kkkk kkkk  F kkkk kkkk kkkk 
;
	RRNCF	TBLPTRU, F	    ;    ,
	RRCF	TBLPTRH, F	    ;     
	RRCF	TBLPTRL, F

       	movff	FlBufPTRL,FSR0L	    ;     
	movff	FlBufPTRH,FSR0H	    ;      :
	
	movff   TBLPTRL,POSTINC0    ; 0:7  	
	movlw	0xEF		    ;  
	movwf   POSTINC0    
	
	movff   TBLPTRH,POSTINC0    ; 8:15  
    
	movlw	0xF0		    ; 16:20 -  
	iorwf	TBLPTRU,W
	movwf   POSTINC0		

       	movff	FSR0L,FlBufPTRL	    ;     
	movff	FSR0H,FlBufPTRH	    ; .

;	   goto   while,   
;	 ,      .    
;             .

	movf	 FlCodeBEGH,W	    ;  FSR0 . 
        subwf    FSR0H,F	    ;  -  .
	movf     FlCodeBEGL,W
	subwf    FSR0L,F			
	btfss    STATUS,C	    ;  
	decf	 FSR0H,F	    ;  ,     1
;
;	  FSR0H/FSR0L -  .  
;
	movff	HereCODEL,TBLPTRL	;   
	movff	HereCODEH,TBLPTRH	;    goto. 
	movff	HereCODEU,TBLPTRU	;     HereCODE

	movf	FSR0L,W			;     
	addwf	TBLPTRL,F		; .  .
	btfsc   STATUS,C
	incf    TBLPTRH,F    
	btfsc   STATUS,C
	incf    TBLPTRU,F    

	movf	FSR0H,W
	addwf	TBLPTRH,F
	btfsc   STATUS,C
	incf    TBLPTRU,F    

;	  goto:  EF kkkk kkkk  F kkkk kkkk kkkk 

	RRNCF	TBLPTRU, F	    ;    , 
	RRCF	TBLPTRH, F	    ;     
	RRCF	TBLPTRL, F

	movlw	CWHILE 
	call	FindCOMMAND

	addlw	.1
	movff	PLUSW2,FSR0L	    ;    
	addlw	.1
	movff	PLUSW2,FSR0H	    ; while/goto   

	movff   TBLPTRL,POSTINC0    ; 0:7  	
	movlw	0xEF		    ;  
	movwf   POSTINC0    

	movff   TBLPTRH,POSTINC0    ; 8:15  

	movlw	0xF0		    ; 16:20 -  
	iorwf	TBLPTRU,W
	movwf   POSTINC0		

	call	LeaveRESOLVE		;  goto    
	
	call	ClearLOOP
	
	return
	
ForwardMARK:

    	movff	FlBufPTRL,FSR0L		;    .
	movff	FlBufPTRH,FSR0H
    
	movff   FSR0H,POSTDEC1		;       
	movff   FSR0L,POSTDEC1		;   GOTO -  .
	
	movlw	0xFF			;     goto,
	movwf   POSTINC0		;   - end.
	movwf   POSTINC0		
	movwf   POSTINC0
	movwf   POSTINC0
	
    	movff	FSR0L, FlBufPTRL	;    .
	movff	FSR0H, FlBufPTRH	
    
	return
    
ForwardRESOLVE:

	movff	FlBufPTRH,FSR0H    	;      
	movff	FlBufPTRL,FSR0L		; .

	;    IF    
	;     goto    END.

	;     .   
	;    .  .

	movf    FlCodeBEGH,W		; FSR0 .    
        subwf   FSR0H,F			;    255 .

	movf    FlCodeBEGL,W
	subwf   FSR0L,F			;    255 .
	btfss   STATUS,C		;   ,   2-3 
	decf	FSR0H,F			; ,     1

	;   FSR0H/FSR0L -  .  

	movff	HereCODEL,TBLPTRL	;   
	movff	HereCODEH,TBLPTRH	;    goto. 
	movff	HereCODEU,TBLPTRU	;     HereCODE

	movf	FSR0L,W			;     
	addwf	TBLPTRL,F		; .  .
	btfsc   STATUS,C
	incf    TBLPTRH,F    
	btfsc   STATUS,C
	incf    TBLPTRU,F    

	movf	FSR0H,W
	addwf	TBLPTRH,F
	btfsc   STATUS,C
	incf    TBLPTRU,F    

	;   goto:  EF kkkk kkkk  F kkkk kkkk kkkk 

	movff	PREINC1,FSR0L	    ;    
	movff	PREINC1,FSR0H	    ; goto   

	RRNCF	TBLPTRU, F	    ;    , 
	RRCF	TBLPTRH, F	    ;     
	RRCF	TBLPTRL, F

	movff   TBLPTRL,POSTINC0    ; 0:7  	
	movlw	0xEF		    ;  
	movwf   POSTINC0    
	
	movff   TBLPTRH,POSTINC0    ; 8:15  
    
	movlw	0xF0		    ; 16:20 -  
	iorwf	TBLPTRU,W
	movwf   POSTINC0		
	
    	;movff	FSR0L, FlBufPTRL	
	;movff	FSR0H, FlBufPTRH	

	return
	
MakeNameFields:
    
	call	GetWORD			;     
					; -.
	Call	ReadCodeHERE		;       
					;  FlCodeBEG/FlBufPTR

	movff	FlBufPTRH,FSR0H	    	;      
	movff	FlBufPTRL,FSR0L		; .
	
	movf	fwLength,w		;  
	movwf	POSTINC0		; 

	movlw	.0			;  
	movwf	POSTINC0		; 

	movff	LastWORDL,POSTINC0	;   
	movff	LastWORDH,POSTINC0	; 

	movff	fwLength,tLen		;     .
	movff	FSR0L,FlBufPTRL		;     
	movff	FSR0H,FlBufPTRH		;  .

	movff	FWordPTRH,POSTDEC1	;      
	movff	FWordPTRL,POSTDEC1	;   -
	
CopyNameField:

	movff	FWordPTRL,FSR0L		;     
	movff	FWordPTRH,FSR0H		;  -.

	movf	POSTINC0,w		

	movff	FSR0L,FWordPTRL
	movff	FSR0H,FWordPTRH

	movff	FlBufPTRL,FSR0L
	movff	FlBufPTRH,FSR0H

	movwf	POSTINC0

	movff	FSR0L,FlBufPTRL		; FSR0 -    
	movff	FSR0H,FlBufPTRH		;    .
	
	DECFSZ  tLen			; ӣ  ?
	BRA	CopyNameField	

	movff	PREINC1,FWordPTRL	;    ģ
	movff	PREINC1,FWordPTRH	;  .
	
	BTFSS	FSR0L,0			;      
	bra	EndMakeParityAddress	;    ޣ.
	movlw	.0			;  nop,  .
	movwf	POSTINC0		
;	
EndMakeParityAddress:
;
    	movff	FSR0L,FlBufPTRL		;   .
	movff	FSR0H,FlBufPTRH		;  .
	return

CompileRETURN:
	
    	movff	FlBufPTRL,FSR0L		;    
	movff	FlBufPTRH,FSR0H		 ; .
	
	movlw	UPPER RCLEN		;    :
	movwf	TBLPTRU			; return
	movlw	HIGH  RCLEN		
	movwf	TBLPTRH			
	movlw	LOW   RCLEN		
	movwf	TBLPTRL			

    	tblrd	*+			;      
	movff   TABLAT,tLen		;  . 

CopyCommandReturn:			
    
    	tblrd	+*			; +* -    dw
	movff	TABLAT,POSTINC0		
	DECFSZ  tLen			;    ?
	BRA	CopyCommandReturn

    	movff	FSR0L, FlBufPTRL	;     
	movff	FSR0H, FlBufPTRH	;   .

	return

RCLEN:	dw	RCEND - RCBEG		;   return 
RCBEG:	return	
RCEND:
;
;
;
CompileXORE:
    
        btfsc	ForthConfiguration,COMPILATOR
	goto	BeginCompileXORE
	
	movf 	PREINC1,W
	xorwf	LATE,f
	
	return
	
BeginCompileXORE:
    
    	movff	FlBufPTRL,FSR0L		;    
	movff	FlBufPTRH,FSR0H		; .
	
	movlw	UPPER RCLEN		;    :
	movwf	TBLPTRU			; return
	movlw	HIGH  RCLEN		
	movwf	TBLPTRH			
	movlw	LOW   RCLEN		
	movwf	TBLPTRL			

    	tblrd	*+			;      
	movff   TABLAT,tLen		;  . 

CopyXORE:			

    	tblrd	+*			; +* -    dw
	movff	TABLAT,POSTINC0		
	DECFSZ  tLen			;    ?
	BRA	CopyXORE

    	movff	FSR0L, FlBufPTRL	;     
	movff	FSR0H, FlBufPTRH	;   .

	return

XELEN:	dw	XEBEG - XEEND		;   .
XEBEG:	movf	PREINC1,W
	xorwf   LATE,F
XEEND:
;
WriteCodeA:
;
;	       FLBufferA +128
;	
	movff	HereCODEU,TBLPTRU	;     
	movff	HereCODEH,TBLPTRH	;   , 64-  
	movff	HereCODEL,TBLPTRL	;   .
	movlw	B'11000000'		;  0:5 .
	andwf	TBLPTRL,f		;    64-  
	movlw	.128			;    
	addwf	TBLPTRL,f
	movlw	.0
	addwfc	TBLPTRH,f
	addwfc	TBLPTRU,f
	Call	EraseCodeHERE		; 

	movff	HereCODEU,TBLPTRU
	movff	HereCODEH,TBLPTRH
	movff	HereCODEL,TBLPTRL
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	movlw	.128
	addwf	TBLPTRL,f
	movlw	.0
	addwfc	TBLPTRH,f
	addwfc	TBLPTRU,f
	lfsr	FSR0,FLBufferA		  ;    .  
	Call	WriteCodeHERE
    
	return
	
WriteCodeB:
;			  
;	       FLBufferB
;           
	movff	HereCODEU,TBLPTRU	;     
	movff	HereCODEH,TBLPTRH	;   , 64-  
	movff	HereCODEL,TBLPTRL	;   .
	movlw	B'11000000'		;  0:5 .
	andwf	TBLPTRL,f		;    64-  
	
	movlw	0x01			;  256 
	addwf	TBLPTRH,f
	addwfc	TBLPTRU,f
	Call	EraseCodeHERE		

	movff	HereCODEU,TBLPTRU
	movff	HereCODEH,TBLPTRH
	movff	HereCODEL,TBLPTRL
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	
	movlw	0x01
	addwf	TBLPTRH,f
	addwfc	TBLPTRU,f
	lfsr	FSR0,FLBufferB		  ;    .  
	Call	WriteCodeHERE
    
	return
	
;    
EndCompilation:
;
;	       FLBufferL
;
	call    CompileRETURN

	movff	HereCODEU,TBLPTRU	;   
	movff	HereCODEH,TBLPTRH	;    , 64-  
	movff	HereCODEL,TBLPTRL	;  flash . 
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	Call	EraseCodeHERE		;  .
	
	movff	HereCODEU,TBLPTRU	 
	movff	HereCODEH,TBLPTRH
	movff	HereCODEL,TBLPTRL
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	lfsr	FSR0,FLBufferL		;   .
	Call	WriteCodeHERE		;   	
;
;	       FLBufferH
;	
	movff	HereCODEU,TBLPTRU	;     
	movff	HereCODEH,TBLPTRH	;   , 64-  
	movff	HereCODEL,TBLPTRL	;   .
	movlw	B'11000000'		;  0:5 .
	andwf	TBLPTRL,f		;    64-  
	movlw	.64			;    
	addwf	TBLPTRL,f
	movlw	.0
	addwfc	TBLPTRH,f
	addwfc	TBLPTRU,f
	Call	EraseCodeHERE		; 

	movff	HereCODEU,TBLPTRU
	movff	HereCODEH,TBLPTRH
	movff	HereCODEL,TBLPTRL
	movlw	B'11000000'	    
	andwf	TBLPTRL,f
	movlw	.64
	addwf	TBLPTRL,f
	movlw	.0
	addwfc	TBLPTRH,f
	addwfc	TBLPTRU,f
	lfsr	FSR0,FLBufferH		  ;    .  
	Call	WriteCodeHERE
;
;	       FLBufferH
;
;	.    > 64    FLBufferA
;
	call WriteCodeA
	call WriteCodeB
;
	movff	HereCODEL,LastWORDL	  ;     
	movff	HereCODEH,LastWORDH	  ;     
	movff	HereCODEU,LastWORDU	

	movf	FlCodeBEGL,w		  ;    
	subwf	FlBufPTRL,w		  ;      255 .  

	addwf	HereCODEL,f		  ;       
	movlw	.0			  ;   .
	addwfc	HereCODEH,f
	addwfc	HereCODEU,f

	;call	debugExecute		  ;  . 

	return
;	
;	 .       . 
;	
debugExecute:

	movf	LastWORDU,w		;   .
	movwf	TBLPTRU
	movf	LastWORDH,w
	movwf	TBLPTRH
	movf	LastWORDL,w
	movwf	TBLPTRL

    	tblrd	*+			;   
	movf 	TABLAT,W
	movwf	tLen

    	tblrd	*+			;  
	
    	tblrd	*+			;     
    	tblrd	*+			 

SkipNameWORD
	tblrd	*+			;   
	movf	TABLAT,W		;   .
	decfsz  tLen 
	BRA	SkipNameWORD

	BTFSC	TBLPTRL,0		;    ޣ.
	tblrd	*+			
	
	incf	STKPTR, F		;     .
	movf	TBLPTRL, W
	movwf	TOSL
	movf	TBLPTRH, W
	movwf	TOSH
	movf	TBLPTRU, W
	movwf	TOSU
	
    	tblrd	*+			;   .
    	tblrd	*+			
    	tblrd	*+			
    	tblrd	*+			
    	tblrd	*+			
    	tblrd	*+			 
    	tblrd	*+			 
    	tblrd	*+			 
    	tblrd	*+			 
    	tblrd	*+			 
    	tblrd	*+			 
	tblrd	*+			 
    	tblrd	*+			 
    	tblrd	*+			 
    	tblrd	*+			 
    	tblrd	*+			 	
	return 
	
;---------------------------------------------------------------------------
;	   ,   .
;---------------------------------------------------------------------------

CompileNUMBER:	

    movff	FlBufPTRL,FSR0L	    ;    
    movff	FlBufPTRH,FSR0H	    ; .
    
    ;   movlw:  0000 1110 kkkk kkkk

    movf	PREINC1,w	    ;   WREG   
    movwf	POSTINC0	    ;     

    movlw	0x0E		    ;   movlw
    movwf	POSTINC0

    movlw	UPPER DLEN	    ;     
    movwf	TBLPTRU		    ;  WREG  .
    movlw	HIGH  DLEN	    ; movwf POSTDEC1
    movwf	TBLPTRH			
    movlw	LOW   DLEN
    movwf	TBLPTRL			
    tblrd	*+		    ;      
    movff 	TABLAT,tLen	    ;  . 

CopyCommanPUSH:

    tblrd	+*		    ; +* -    dw
    movff	TABLAT,POSTINC0		
    DECFSZ	tLen		    ;    ?
    BRA		CopyCommanPUSH
    
    movff	FSR0L, FlBufPTRL    ;     
    movff	FSR0H, FlBufPTRH    ;   .

    return

DLEN:	dw	DEND - DBEG	    ;      
DBEG:	movwf	POSTDEC1
DEND:	    
    
CompileCALL:	
	
    movff	FlBufPTRL,FSR0L	    ;    
    movff	FlBufPTRH,FSR0H	    ; .

    RRNCF	TBLPTRU, F	    ;    , 
    RRCF	TBLPTRH, F	    ;     
    RRCF	TBLPTRL, F

    ;   call:  EC kkkk kkkk  F kkkk kkkk kkkk 

    movff       TBLPTRL,POSTINC0    ; 0:7  	
    
    movlw	0xEC		    ;  
    movwf       POSTINC0	    

    movff       TBLPTRH,POSTINC0    ; 8:15  
    
    movlw	0xF0		    ; 16:20 -  
    iorwf	TBLPTRU,W
    movwf       POSTINC0		

    movff	FSR0L, FlBufPTRL    ;     
    movff	FSR0H, FlBufPTRH    ;   .

    return

ow_480us    movlw   0x07		;   5.2 
	    movwf   OwCount
ow_480us1:  movlw   0x16		;   
	    movwf   TMR0L
	    bsf     T0CON,TMR0ON
ow_480us2:  btfsc   T0CON,TMR0ON	; ģ     
	    bra	    ow_480us2
	    DECFSZ  OwCount
	    bra	    ow_480us1
	    return

ow_240us    movlw   0x04		
	    movwf   OwCount
ow_240us1:  movlw   0x3A		;   
	    movwf   TMR0L
	    bsf     T0CON,TMR0ON
ow_240us2:  btfsc   T0CON,TMR0ON	; ģ     
	    bra	    ow_240us2
	    DECFSZ  OwCount
	    bra	    ow_240us1
	    return

ow_60us     movlw   0x3E		;   
	    movwf   TMR0L
	    bsf     T0CON,TMR0ON
ow_60us1:   btfsc   T0CON,TMR0ON	; ģ     
	    bra	    ow_60us1
	    return

ow_50us     movlw   0x64		;   
	    movwf   TMR0L
	    bsf     T0CON,TMR0ON
ow_50us1:   btfsc   T0CON,TMR0ON	; ģ     
	    bra	    ow_50us1
	    return

ow_40us     movlw   0x83		;   
	    movwf   TMR0L
	    bsf     T0CON,TMR0ON
ow_40us1:   btfsc   T0CON,TMR0ON	; ģ     
	    bra	    ow_40us1
	    return

ow_15us     movlw   0xF1		;   11.3 
	    movwf   TMR0L
	    bsf     T0CON,TMR0ON
ow_15us1:   btfsc   T0CON,TMR0ON	; ģ     
	    bra	    ow_15us1
	    return
	    
ow_10us     movlw   0xFF		;   11.3 
	    movwf   TMR0L
	    bsf     T0CON,TMR0ON
ow_10us1:   btfsc   T0CON,TMR0ON	; ģ     
	    bra	    ow_10us1
	    return
    
ow_05us     movlw   0x03		;   4.6 
	    movwf   OwCount
ow_05us1:   DECFSZ  OwCount
	    bra	    ow_05us1
	    return
;
;	      	    
;	    
ow_reset:   OWLOW		    ;  -     480us. 
	    call    ow_480us		
	    OWHIGH		    ;  
	    call    ow_60us	    ; ģ 60 	    

	    OWBTFSS		    ;     ,
	    bra      ow_s240us	    ;    .
	    movlw   .1		    ;      . 
	    movwf   POSTDEC1	    ; 1-    .  
	    movwf   POSTDEC1	    ; 1-     .
	    return

ow_s240us:  movlw   0x04	    ;    240us
	    movwf   OwCount	    ;      
	    
ow_l240us:  movlw   0x3A	    ;     
	    movwf   TMR0L	    ;     +5V
	    bsf     T0CON,TMR0ON

ow_bchk:    OWBTFSS		
	    bra     ow_blow
	    clrf    POSTDEC1	    ; 0 -     
	    movlw   .1		    
	    movwf   POSTDEC1	    ; 1 -   	
	    return

ow_blow:    btfsc   T0CON,TMR0ON    ; ģ     
	    bra	    ow_bchk
	    DECFSZ  OwCount
	    bra	    ow_l240us

	    clrf    POSTDEC1	    ; 0 -     
	    clrf    POSTDEC1	    ; 0 -    .

	    return
;
;    .       WREG
;	    
ow_send_byte:

	    movf      PREINC1,W	
	    movlw     8
	    movwf     FSR0L	    ; ޣ   

OW_BIT:     btfss     INDF1,0
	    bra	      OW_BITZ

	    OWLOW		    ;     
	    call      ow_05us
	    OWHIGH

	    call      ow_60us
	    bra	      OW_BITN

OW_BITZ:    OWLOW		    ;    
	    call      ow_60us
	    OWHIGH
	    call      ow_05us

OW_BITN:    RRNCF     INDF1,f	
	    DECFSZ    FSR0L
	    bra	      OW_BIT
    
	    return
;
;    
;
ow_receive_byte

	    movlw     .8
	    movwf     FSR0L	    ; ޣ   
	    clrf      INDF1

OW_IBIT:    OWLOW		    ;     

	    call	ow_05us
	    OWHIGH
	    call	ow_15us

	    bsf		INDF1,0
	    OWBTFSS 
	    bcf		INDF1,0

	    call	ow_40us

	    RRNCF	INDF1,f	
	    DECFSZ	FSR0L
	    bra		OW_IBIT

	    movf	INDF1,w
	    movf	POSTDEC1,w

	    return
;
;   
;	    
	    
ow_init:    clrf	OwBit
	    clrf	ow_rcode	
	    
 	    movlw	.63	
	    movwf	OwByteCount
	    lfsr	FSR0,OwArray

ow_clear:   decf	OwByteCount,w
	    movwf	OwByteCount
	    clrf	PLUSW0
	    xorlw	0x00
	    bnz		ow_clear
	    
	    return
;
;       .    WREG 
;	    
;   WREG = 3 (  1-Wire )
;   WREG = 4 (   -  )	    
;
OW_NEXT_RESET:  
	    OWLOW		    ;  -     480us. 
	    call    ow_480us		
	    OWHIGH		    ;  
	    call    ow_60us	    ; ģ 60 	    

	    OWBTFSS		    ;     ,
	    bra      ow_ns240us	    ;    .
	    movlw   .3		    ;      . 
	    return

ow_ns240us: movlw   0x04            ;    240us
	    movwf   OwCount	    ;      

ow_nl240us: movlw   0x3A	    ;     
	    movwf   TMR0L	    ;     +5V
	    bsf     T0CON,TMR0ON

ow_nbchk:   OWBTFSS 		
	    bra	    ow_nblow
	    movlw   .0		    ;    . 
	    return

ow_nblow:
	    btfsc   T0CON,TMR0ON    ; ģ     
	    bra	    ow_nbchk
	    
	    DECFSZ  OwCount	    ;    .
	    bra	    ow_nl240us
	    
	    movlw   .4		    ;   .  
	    return
;
;          
; ̣ .      ݣ  . 
;    
ow_next:    
	    call    OW_NEXT_RESET
	    movwf   ow_rcode
	    xorlw   0x00
	    bz	    OW_NEXT_INIT
	    return

OW_NEXT_INIT:

	    movlw   0xF0
	    movwf   POSTDEC1
	    call    ow_send_byte

	    clrf    OwIndex		;  
	    movlw   .8
	    movwf   OwByteCount		; ޣ   

OW_NEXT_BYTE:

	    movlw   .8
	    movwf   OwBitCount		; ޣ   
	    clrf    INDF1

;   0 	0      ROM   '0',  '1'.  ? . 	    
;   0 	1        ROM  '0'
;   1 	0        ROM  '1'	    
;   1 	1    ,   . 	    

OW_NEXT_BIT:

	    OWLOW			;     
	    call      ow_05us		; ,   .
	    OWHIGH			 
	    call      ow_15us
	    bcf	      OwBit,owFirstBIT
	    OWBTFSC			
	    bsf	      OwBit,owFirstBIT		
	    call      ow_40us
;
	    OWLOW			;     
	    call      ow_05us		; ,   
	    OWHIGH
	    call      ow_15us
	    bcf	      OwBit,owSecondBIT
	    OWBTFSC			
	    bsf	      OwBit,owSecondBIT
	    call      ow_40us
;
	    btfsc    OwBit,owFirstBIT	; 
	    bra	     B0_NotZero

	    btfsc    OwBit,owSecondBIT
	    bra	     B0_Zero_B1_NotZero 
;
;    0	0       ROM   '0',  '1' - ̣.
;	    
;   ̣ -       
;    N,       ( ),   
;   ( ).  OwArray  64 .   ̣,
;       ,    .

	    movf    OwIndex,W		    ; ,    
	    lfsr    FSR0,OwArray	    ;     ̣.

	    btfss   PLUSW0,owLeft 	    ;    ? 
	    bra	    GO_RIGHT		    ;     .    

	    bcf	    INDF1,0		    
	    bra	    OW_SendNEXT_BIT	    

GO_RIGHT    bsf     PLUSW0,owRight	    ;    
	    bsf	    INDF1,0		    ;      
	    bra	    OW_SendNEXT_BIT	    ; 

B0_NotZero  btfsc   OwBit,owSecondBIT
	    bra	    B0_NotZero_B1_NotZero

;   1 	0          ROM  '1'

	    bsf	    INDF1,0	    
	    bra	    OW_SendNEXT_BIT

B0_NotZero_B1_NotZero:

;   1 	1    ,   . .

	    movlw   .2			;  ,   . 	
	    movwf   ow_rcode		;  .   .

OW_SCLR1:   movf    OwByteCount,W
	    xorlw   .8
	    bnz	    OW_SCLR2
	    return

OW_SCLR2:   movf    PREINC1,w
	    incf    OwByteCount
	    bra	    OW_SCLR1
	    
B0_Zero_B1_NotZero:

;   0 	1        ROM  '0'
	    
	    bcf	    INDF1,0

OW_SendNEXT_BIT:

	    btfss   INDF1,0
	    bra	    OW_SendBIT_Zero

	    OWLOW			;     
	    call    ow_05us
	    OWHIGH
	    call    ow_60us
	    bra	    OW_SaveBIT

OW_SendBIT_Zero:    

	    OWLOW			;    
	    call      ow_60us
	    OWHIGH
	    call      ow_05us

OW_SaveBIT:
	    incf	OwIndex		;   .
	    RRNCF	INDF1,f		;    
	    DECFSZ	OwBitCount	;    ?  ,
	    bra		OW_NEXT_BIT	;   ɣ 

	    movf	INDF1,w		;  ,   
	    movf	POSTDEC1,w	;  . 

	    DECFSZ	OwByteCount	;   - 8 .
	    bra		OW_NEXT_BYTE
;			
;     ۣ.    .
; 	    
	    movlw	.63
	    movwf	OwIndex
	    lfsr	FSR0,OwArray

ow_loop	    clrf	PLUSW0
	    decf	OwIndex,w
    	    movwf	OwIndex
	    xorlw	0x00
	    bnz		ow_cnode

	    movlw	.1		; ,   
	    movwf	ow_rcode	
	    return

ow_cnode    btfss	PLUSW0,owRight	;     , 
	    bra		ow_loop		;     .

	    btfsc	PLUSW0,owLeft 	;    , 
	    bra		ow_loop		;     .

	    bsf		PLUSW0,owLeft	;     

	    movlw	.0		; ,   ݣ 
	    movwf	ow_rcode	
	    return
	    
;   :  http://vpn88.livejournal.com/44279.html

;   NFA  -  Name Field Address -   
;   LFA  -  Link Field Address -   
;   CFA  -  Code Field Address -   
;   PFA  -  Parameter Field Address -   

;   Flags for the Name Field

BitCOMPILE	equ	 0x00		    
BitINLINE	equ	 0x01
BitIMMED	equ	 0x02
BitNFA		equ	 0x03
BitNFAmask	equ	 0x04

COMPILE		equ	 0x01		    
INLINE		equ	 0x02
IMMED		equ	 0x04
NFA		equ	 0x08
NFAmask		equ	 0x10

		org	 0x9E0		

VariablesCODE	dw       0x0000		; HeapMEML:HeapMEMH	
		dw	 0x0000		; +4    
		dw	 0x0000		; +4    
		dw	 0x0000		; +4    

		db	 "11111111222222223333333344444444"
		db	 "555555556666666677777777"

		org	 0x03100
		
eword	        db       "  [word not found]",0
estack	        db       "  [stack is empty]",0
epairs		db       "  [missing openinig bracket]",0
		
;HeapMEMORY	dw	 Free	
	
VocFRT		db	 .5,0x00	;  , 	    
		dw	 0x0000    	;    
		db       "FORTH"	; Name 
		return			

WEMIT		db	.4,0x00		; ( c --  ) 
		dw      VocFRT		;   RS232   
		db      "emit"		
wtx:		BTFSS	PIR1, TXIF	;  
		BRA	wtx
		movff	PREINC1,TXREG	
		return   		

WSPACE		db	 .5,0x00	;      .
		dw       WEMIT			
		db       "space"	
		movlw	 0x20
		call	 ByteOUT
		return   		

	
WCR		db	 .2,0x00	;    rs232 ( ).
		dw       WSPACE		;   .
		db       "cr"		
		call	 OUTrs232
		return   		

WRED 		db	 .3,0x00	;    
		dw       WCR		;    
		db       "red"		;  . 
		movlw	 b'00000100'
		xorwf	 LATE,1         
		return

WHEX		db	 .3,0x00	;    
		dw       WRED		;    ASCII 
		db       "hex"		;    
		movff    PREINC1,tHex
WHEX1:		movf	 tHex,W
		xorlw    .0
		bz	 WHEX2   
		call	 HEXtoASCII
		decf	 tHex   
		bra	 WHEX1
WHEX2:		return   		
		

WX2C		db	 .3,0x00	;    
		dw       WHEX		;    ASCII 
		db       "x2c"		;    
		call	 HEXtoASCII
		return   		

WH2C		db	 .3,0x00	;    
		dw       WX2C		;    ASCII 
		db       "h2c"		;    
		call	 HEXtoASCII
		return   		

WB2C		db	.3,0x00	    	; ( b -- )      
		dw      WH2C		;    ASCII   
		db      "b2c"		;    .
		call	BinaryToAscii
		return   		
;
;		1-WIRE
;
WOW_RESET	db	.8,0x00	    	; ( -- b b ) 
		dw      WB2C		;   (1 , 0 - )
		db      "ow_reset"	;    
		call	ow_reset	; 0 -  , 1 -  
		return			

WOW_READ 	db	.7,0x00	    	; ( b -- ) 
		dw      WOW_RESET	;  
		db      "ow_read"	
		movff   PREINC1,OwBytes
WOW_READ1	call    ow_receive_byte
		DECFSZ  OwBytes
		bra	WOW_READ1
		return

WOW_SEND 	db	.7,0x00	    	; ( b -- ) 
		dw      WOW_READ	;  
		db      "ow_send"	
		call	ow_send_byte
		return

WOW_RECEIVE	db	.10,0x00	; ( n -- b b b ... ) 
		dw      WOW_SEND 	;  
		db      "ow_receive"	
		call	ow_receive_byte
		return
;
;
;		
WOW_RC     	db	.5,0x00		; ( -- b ) 
		dw	WOW_RECEIVE	;  
		db      "ow_rc"
		movff   ow_rcode,POSTDEC1
		return
;		
; ow_init ow_next ow_rc h2c space h2c h2c h2c h2c h2c h2c h2c cr
;		
WOW_NEXT   	db	.7,0x00		; ( -- ) 
		dw	WOW_RC     	;  
		db      "ow_next"
		call	ow_next
		return
;
WOW_INIT   	db	.7,0x00		; ( -- b b )
		dw      WOW_NEXT   	;  
		db      "ow_init"
		call	ow_init 
		return
;
;		   . 
;
WTIMER0_GET	db	.7,0x00	    	; ( -- TMR0L TMR0H ) 
		dw      WOW_INIT	;    .
		db      "TIMER0@"	
		movff   TMR0L,POSTDEC1
		return

WTIMER0_SET	db	.7,0x00	    	; ( b b -- ) 
		dw      WTIMER0_GET	;    
		db      "TIMER0!"	;   
		movff	PREINC1,TMR0L
		bsf     T0CON,TMR0ON	;  ,  .
		return

WTIMER0_ON	db	.12,0x00	; (  -- ) 
		dw      WTIMER0_SET	;  
		db      "Start_TIMER0"	
		bsf     T0CON,TMR0ON
		return

WTIMER0_OFF	db	.11,0x00		; (  -- ) 
		dw      WTIMER0_ON	;  
		db      "Stop_TIMER0"	
		bcf     T0CON,TMR0ON
		return
		
WTIMER0_TEST	db	.7,0x00		; (  -- ) 
		dw      WTIMER0_OFF	;  
		db      "TIMER0?"	
		movlw	 .1
		movwf    POSTDEC1
	        BTFSS    T0CON,TMR0ON	;  ?
		clrf     PLUSW1
		return
;
WCOLON		db	.1,0x00	    	;    
		dw      WTIMER0_TEST	;      
		db      ":"		;   .
		call    PairsPUSH	;   if/end  
		call    MakeNameFields	;      .
		bsf     ForthConfiguration,COMPILATOR 
		return   		

WRETURN	    	db	.6,0x00	    	;   return
		dw      WCOLON	
		db      "return"	
		call    CompileRETURN
		return   		

WSEMIC		db	.1,COMPILE    	;   
		dw      WRETURN	    	;    
		db      ";"		;      .
		call	EndCompilation
		call    PairsPOP	;   if/end    .
		bcf     ForthConfiguration,COMPILATOR
		return   		

WBREAK		db	.5,COMPILE    	;   .
		dw      WSEMIC
		db      "leave"		
		call	CompileLEAVE
		return
		
WBEGIN		db	.5,COMPILE    	;   .
		dw      WBREAK
		db      "begin"		
		call	CompileBEGIN
		return

WUNTIL		db	.5,COMPILE    	;     
		dw      WBEGIN		;    (),   
		db      "until"		;     
		call	CompileUNTIL	;   BEGIN. 
		return

WWHILE		db	.5,COMPILE    	;     
		dw      WUNTIL		;    (),    -
		db      "while"		;     
		call	CompileWHILE	;   BEGIN. 
		return

WREPEAT		db	.6,COMPILE    	;      FSR2  
		dw      WWHILE		; ,   
		db      "repeat"	;   goro  e while
		call	CompileREPEAT	
		return			; ;    repeat -> do  

WAGAIN 		db	.5,COMPILE    	;      FSR2  
		dw      WREPEAT		; ,   
		db      "again"		;   goro  e while
		call	CompileAGAIN 	
		return			; ;    repeat -> do  
		
WIF   		db	.2,COMPILE    	;   
		dw      WAGAIN	    	;    
		db      "if"		;      .
		call	CompileIF
		return

WELSE 		db	.4,COMPILE    	;   GOTO
		dw      WIF		;    .
		db      "else"
		call	CompileELSE
		return

WEND  		db	.3,COMPILE    	;   GOTO
		dw      WELSE		;    .    
		db      "end"		
		call	ForwardRESOLVE	;   ң
		return   		
;
;============================================================================
;
WXORE  		db	.4,0    	;   GOTO
		dw      WEND  		;    .    
		db      "XORE"		
		call	CompileXORE	;   ң
		return   		

WPORTE		db	.5,0x00		; ( --  )
		dw      WXORE 		;     E
		db      "PortE"
		lfsr	0,LATE
		movff	FSR0H,POSTDEC1
		movff	FSR0L,PREINC1
		return	
;
WPORTE_CLR 	db	.4,0x00		; ( b --  )
		dw      WPORTE		;    :
		db	"CLRE"	    	
		clrf	TRISE
		return   		
;
WPORTE_AND	db	.6,0x00		; AND      A:
		dw      WPORTE_CLR	 
		db      "PORTE&"
		movf    PREINC1,W
		andwf   LATE,F	    
		return   		
;		
WPORTE_XOR	db	.6,0x00		; XOR      A:
		dw      WPORTE_AND
		db      "PORTE^"
		movf    PREINC1,W
		xorwf   LATE,F
		return
;		
WPORTE_OR	db	.6,0x00		; OR      A:
		dw      WPORTE_XOR
		db      "PORTE|"
		movf    PREINC1,W
		iorwf   LATE,F
		return
;
WPORTE_GET	db	.6,0x00		; ( b --  )
		dw      WPORTE_OR	;    :
		db      "PORTE@"    	; 1 - input 
		movff   LATE,POSTDEC1   ; 0 - output
		return   		
;
WPORTE_SET	db	.6,0x00		; ( b --  )
		dw      WPORTE_GET	;     A:
		db      "PORTE!"	; 1 - input 
		movff   PREINC1,LATE	; 0 - output
		return
;
WTRISE_OR 	db	.6,0x00		; ( b --  )
		dw      WPORTE_SET	;  OR     TRISA 
		db      "TRISE|"	
		movf    PREINC1,W    
		iorwf   TRISE,f 
		return   		
;
WTRISE_XOR 	db	.6,0x00		; ( b --  )
		dw      WTRISE_OR 	; OR     TRISA 
		db      "TRISE^"	
		movf    PREINC1,W    
		xorwf   TRISE,f 
		return   		
;
WTRISE_AND 	db	.6,0x00		; ( b --  )
		dw      WTRISE_XOR	; OR     TRISA 
		db      "TRISE&"	
		movf    PREINC1,W    
		andwf   TRISE,f 
		return   		

WTRISE_GET	db	.6,0x00		; ( b --  )
		dw      WTRISE_AND	;    :
		db      "TRISE@"    	; 1 - input 
		movff   TRISE,POSTDEC1  ; 0 - output
		return   		

WTRISE_SET	db	.6,0x00		; ( b -- )
		dw      WTRISE_GET	;     A:
		db      "TRISE!"	; 1 - input 
		movff   PREINC1,TRISE	; 0 - output
		return   		
;		
WANSELE_GET	db	.7,0x00		; ( -- b )
		dw      WTRISE_SET	;    ANSELA
		db      "ANSELE@"	
		movff   ANSELE,POSTDEC1
		return   		

WANSELE_SET	db	.7,0x00		; ( a b -- b a )
		dw      WANSELE_GET	;   -    
		db      "ANSELE!"	; 1 - Analog  
		movff   PREINC1,ANSELE	; 0 - Digital
		return
;
;============================================================================
;
WPORTA_CLR 	db	.4,0x00		; ( b --  )
		dw      WANSELE_SET	;    :
		db      "CLRA"	    	
		clrf	TRISA
		return   		

WPORTA_AND	db	.6,0x00		; AND      A:
		dw      WPORTA_CLR	 
		db      "PORTA&"    	
		movf    PREINC1,W
		andwf   PORTA,F	    
		return   		
		
WPORTA_XOR	db	.6,0x00		; XOR      A:
		dw      WPORTA_AND
		db      "PORTA^"
		movf    PREINC1,W
		xorwf   PORTA,F
		return
		
WPORTA_OR	db	.6,0x00		; OR      A:
		dw      WPORTA_XOR
		db      "PORTA|"
		movf    PREINC1,W
		iorwf   PORTA,F
		return

WPORTA_GET	db	.6,0x00		; ( b --  )
		dw      WPORTA_OR	;    :
		db      "PORTA@"    	; 1 - input 
		movff   PORTA,POSTDEC1   ; 0 - output
		return   		

WPORTA_SET	db	.6,0x00		; ( b --  )
		dw      WPORTA_GET	;     A:
		db      "PORTA!"	; 1 - input 
		movff   PREINC1,PORTA	; 0 - output
		return   		
;
WTRISA_OR 	db	.6,0x00		; ( b --  )
		dw      WPORTA_SET	;  OR     TRISA 
		db      "TRISA|"	
		movf    PREINC1,W    
		iorwf   TRISA,f 
		return   		
		
WTRISA_XOR 	db	.6,0x00		; ( b --  )
		dw      WTRISA_OR 	; OR     TRISA 
		db      "TRISA^"	
		movf    PREINC1,W    
		xorwf   TRISA,f 
		return   		
;		
WTRISA_AND 	db	.6,0x00		; ( b --  )
		dw      WTRISA_XOR	; OR     TRISA 
		db      "TRISA&"	
		movf    PREINC1,W    
		andwf   TRISA,f 
		return   		
;		
WTRISA_GET	db	.6,0x00		; ( b --  )
		dw      WTRISA_AND	;    :
		db      "TRISA@"    	; 1 - input 
		movff   TRISA,POSTDEC1  ; 0 - output
		return   		
;		
WTRISA_SET	db	.6,0x00		; ( b --  )
		dw      WTRISA_GET	;     A:
		db      "TRISA!"	; 1 - input 
		movff   PREINC1,TRISA	; 0 - output
		return   		
;
WANSELA_GET	db	.7,0x00		; (  -- b  )
		dw      WTRISA_SET	;    ANSELA
		db      "ANSELA@"	
		movff   ANSELA,POSTDEC1
		return   		
;
WANSELA_SET	db	.7,0x00		; ( a b -- b a )
		dw      WANSELA_GET	;      
		db      "ANSELA!"	; 1 - Analog  
		movff   PREINC1,ANSELA	; 0 - Digital
		return   		
;
WHERE		db	.4,0x00		; 
		dw      WANSELA_SET	;     
		db      "here"		
		movff	HereCODEH,POSTDEC1
		movff	HereCODEL,POSTDEC1
		return   		
;
;============================================================================
;
WHEAP		db	.4,0x00		;      .
		dw      WHERE		
		db      "heap"
		movff	HeapMEMH,POSTDEC1
		movff	HeapMEML,POSTDEC1
		return   		
;
WMALLOC		db	.6,0x00		; 
		dw      WHEAP		; 
		db      "malloc"		
		movf    PREINC1,W
		addwf	HeapMEML,f
		movlw	.0
		addwfc	HeapMEMH,f
;
		;call	 VariablesRead	    ;  64      	
		;call	 VariablesModify    ;       
		;call	 VariablesErase	    ;   
		;call	 VariablesWrite	    ;    .
		;call	 VariablesRead	    ;  .
		return   		

WVARIABLE	db	.8,0x00		; 
		dw      WMALLOC		; 
		db      "variable"		
		call	MakeVariable
		return   		

WDEC 		db	.2,0x00		; ( n  --) 
		dw      WVARIABLE	;       1
		db      "1-"
		movlw	1
		decf	PLUSW1
		return

WINC	  	db	.2,0x00		; 
		dw      WDEC		;      1
		db      "1+"
		movlw	1
		incf	PLUSW1
		return

WDUP		db	.3,0x00		; ( n  --) 
		dw      WINC  		;  OR    
		db      "dup"		
		movlw	1
		movff	PLUSW1,POSTDEC1
		return   		

WDROP		db	.4,0x00		; ( n  --)
		dw      WDUP  		;  OR    
		db      "drop"		
		movf	PREINC1,w
		return   		

WIOR 		db	 .2,0x00	; ( n n -- n ) 
		dw       WDROP		;  XOR     
		db       "or"		
		movf	PREINC1,W    
		iorwf	PREINC1,W
		movwf	POSTDEC1
		return

WIORA		db	.3,0x00		; ( n  --) 
		dw      WIOR 		;  OR    
		db      "or!"		
		movff	PREINC1,FSR0L
		movff	PREINC1,FSR0H
		movf	PREINC1,w
		iorwf	INDF0,1
		return   		

WAND 		db	 .3,0x00	; ( n n -- n ) 
		dw       WIORA		;  XOR     
		db       "and"		
		movf	PREINC1,W    
		andwf	PREINC1,W
		movwf	POSTDEC1
		return			    

WAND2ADDR	db	.4,0x00		; ( n  --) 
		dw      WAND		;  AND    
		db      "and!"		
		movff	PREINC1,FSR0L
		movff	PREINC1,FSR0H
		movf	PREINC1,w
		andwf	INDF0,1
		return   		

WELT  		db	.2,0x00		; ( n1 n2 -- flag )  
		dw      WAND2ADDR	; True if n1 <= n2  (signed)
		db      "<=" 
		movf 	PREINC1,W    
		CPFSGT	PREINC1
		bra	WELT1
		clrf  	POSTDEC1
		return
WELT1:		movlw   .1    
		movwf 	POSTDEC1
		return
		
WLT  		db	.1,0x00		; ( n1 n2 -- flag )  
		dw      WELT     	; True if n1 < n2  (signed)
		db      "<" 
		movf 	PREINC1,W    
		CPFSLT	PREINC1
		bra	WLT1
		movlw   .1    
		movwf 	POSTDEC1
		return
WLT1:		clrf  	POSTDEC1
		return
		
WEGT  		db	.2,0x00		; ( n1 n2 -- flag )  
		dw      WLT      	; True if n1 >= n2  (signed)
		db      ">=" 
		movf 	PREINC1,W    
		CPFSLT	PREINC1
		bra	WEGT1
		clrf 	POSTDEC1
		return
WEGT1:		movlw   .1    
		movwf 	POSTDEC1
		return

WGT  		db	.1,0x00		; ( n1 n2 -- flag )  
		dw      WEGT 		; True if n1 > n2  (signed)
		db      ">" 
		movf 	PREINC1,W    
		CPFSGT	PREINC1
		bra	WGT1
		movlw   .1    
		movwf 	POSTDEC1
		return
WGT1:		clrf  	POSTDEC1
		return
		
WNE  		db	.2,0x00		; ( n  --) 
		dw      WGT		;  XOR    
		db      "<>"
		movf 	PREINC1,W    
		xorwf	PREINC1,W
		bz	WNE1
		movlw   .1
		movwf	POSTDEC1
		return

WNE1		movlw    .0
		movwf	POSTDEC1
		return			    

WEQ  		db	 .1,0x00	; ( n n -- n ) 
		dw       WNE	 
		db       "="
		movf 	PREINC1,W    
		xorwf	PREINC1,W
		bz	WEQ1
		movlw    .0
		movwf	POSTDEC1
		return	
WEQ1		movlw    .1
		movwf	POSTDEC1
		return			    

WNOT 		db	 .3,0x00	    ; ( n  --) 
		dw       WEQ		    ; NOT    
		db       "not"
		movlw    .1
		movwf    FSR0L
		TSTFSZ	 PLUSW1
		clrf     FSR0L
		movff    FSR0L, PLUSW1
		return			    

WXOR 		db	 .3,0x00	    ; ( n  --) 
		dw       WNOT		    ;  XOR    
		db       "xor"		
		movf 	PREINC1,W    
		xorwf	PREINC1,W
		movwf	POSTDEC1
		return			    
					
WXOR2ADDR	db	 .4,0x00	    ; ( n  --) 
		dw       WXOR		    ;  XOR    
		db       "xor!"
		movff	PREINC1,FSR0L
		movff	PREINC1,FSR0H
		movf	PREINC1,w
		xorwf	INDF0,f
		return			

WCLS		db	.3,0x00		    ;    rs232 ( ).
		dw      WXOR2ADDR	    ;   .
		db      "cls"		
		lfsr    FSR0,OUTBuffer
		movff   FSR0L,OUTBufL 
		movff   FSR0H,OUTBufH 
		clrf	OUTBufCount	
		movff	FSR0L,BufferPTRL
		movff	FSR0H,BufferPTRH
		clrf	BufferSIZE
		return	
			
WBPUT   	db	.3,0x00		    ; ( -- ) 
		dw      WCLS		    ;    .
		db      "wb!"		    		
		movff	PREINC1,BufferSIZE
		movff	PREINC1,BufferPTRL
		movff	PREINC1,BufferPTRH
		return

WBGET    	db	.3,0x00		    ; ( -- ) 
		dw      WBPUT		    ;    .
		db      "wb@"		
		movff	BufferPTRH,POSTDEC1
		movff	BufferPTRL,POSTDEC1
		movff	BufferSIZE,POSTDEC1
		return

WAPUT   	db	.3,0x00		    ; ( -- ) 
		dw      WBGET		    ;    .
		db      "wa!"		
		movff	PREINC1,BufferPTRL
		movff	PREINC1,BufferPTRH
		return
		
WAGET    	db	.3,0x00		    ; ( -- ) 
		dw      WAPUT		    ;    .
		db      "wa@"		
		movff	BufferPTRH,POSTDEC1
		movff	BufferPTRL,POSTDEC1
		return

WSPUT   	db	.3,0x00		    ; ( -- ) 
		dw      WAGET		    ;    .
		db      "ws!"		
		movff	PREINC1,BufferSIZE
		return

WSGET   	db	.3,0x00		    ; ( -- ) 
		dw      WSPUT		    ;    .
		db      "ws@"		
		movff	BufferSIZE,POSTDEC1
		return

WSAVE  		db	.5,0x00		    ; ( -- ) 
		dw      WSGET		    ;    .
		db      "wsave"
		movff	OUTBufL,BufferPTRL
		movff	OUTBufH,BufferPTRH
		return
;
; ========================================
;		
		
WEXECUTE	db	.7,0x00		    ; ( high low size -- ) 
		dw      WSAVE		    ;    .
		db      "execute"
		movff	PREINC1,TBLPTRL
		movff	PREINC1,TBLPTRH
		movff	PREINC1,TBLPTRU
		goto    CallForthWORD
		return
		
WFIND 		db	.4,0x00		    ; ( high low size -- ) 
		dw      WEXECUTE	    ;    .
		db      "find"
		movff	PREINC1,FindWORDS
		movff	PREINC1,FindWORDL
		movff	PREINC1,FindWORDH
		call    FindWord 
		xorlw   0x00 
		bnz     WFIND1
		movff	TBLPTRU,POSTDEC1
		movff	TBLPTRH,POSTDEC1
		movff	TBLPTRL,POSTDEC1
WFIND1		movwf	POSTDEC1
	
		return
		
WPCHAR		db	 .2,0x00	; ( n  -- ) 
		dw       WFIND		;    .
		db       "c!"		
		movff	PREINC1,FSR0L
		movff	PREINC1,FSR0H
		movf	PREINC1,w
		movwf	INDF0
		return

WGCHAR		db	 .2,0x00	; (  -- c ) 
		dw       WPCHAR		;    .
		db       "c@"		
		movff	PREINC1,FSR0L
		movff	PREINC1,FSR0H
		movff	INDF0,POSTDEC1
		return   		
		
HereCODE	dw	 0

		END

;Page	PCLATH	PCLATH	Start	    End
;Number	bit 4	bit 3	Position    Position
;0	0	0	0x000	    0x7FF
;1	0	1	0x800	    0xFFF
;2	1	0	0x1000	    0x17FF
;3	1	1	0x1800	    0x1FFF
